'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Paper = require('../Paper/Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _AppBarRightToolbar = require('./AppBarRightToolbar');

var _AppBarRightToolbar2 = _interopRequireDefault(_AppBarRightToolbar);

var _Dom = require('../utils/Dom');

var _Dom2 = _interopRequireDefault(_Dom);

var _Events = require('../utils/Events');

var _Events2 = _interopRequireDefault(_Events);

var _styles = require('./styles');

var _injectStyles = require('../styles/injectStyles');

var _injectStyles2 = _interopRequireDefault(_injectStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * AppBar - the main toolbar for the application
 */
var AppBar = function (_Component) {
  _inherits(AppBar, _Component);

  /**
   * Class constructor
   *
   * @param {Object} props Properties to send to the render function
   */

  /**
   * Set accepted properties
   */
  function AppBar(props) {
    _classCallCheck(this, AppBar);

    // Variables used for callback refs
    var _this = _possibleConstructorReturn(this, (AppBar.__proto__ || Object.getPrototypeOf(AppBar)).call(this, props));
    // Call paprent constructor


    _this._onWindowScroll = function () {
      // If the starting state was 0 then do nothing
      if (!_this.props.alwaysVisible) {
        return;
      }

      // Get the scroll offset of the window
      var windowOffset = _Dom2.default.scrollOffset();

      /*
       * If we have scrolled, then follow the scroll.
       * Because the left nav div is position:fixed, then we
       * can move all the way to 0 to be at the top no matter how
       * far down the page they scroll
       */
      var newTop = _this.state.startTopOffset - windowOffset.top;
      if (newTop < 0) {
        newTop = 0;
      }

      // Restore the original state if we are back in the viewport.
      if (windowOffset.top <= _this.state.startTopOffset) {
        newTop = -1; // Reset
      }

      // Set state
      _this.setState({ curTopOffset: newTop });
    };

    _this._onResize = function () {
      // If we never have a fixed element then do nothing
      if (!_this.outerCon || !_this.props.alwaysVisible && !_this.props.fixed) {
        return;
      }

      var offset = _Dom2.default.offset(_this.outerCon);
      _this.setState({
        startTopOffset: offset.top,
        startWidth: offset.width + 'px'
      });
    };

    _this.outerCon = null;
    _this.innerCon = null;

    _this.state = {
      startTopOffset: 0,
      startWidth: 'auto',
      curTopOffset: -1
    };
    return _this;
  }

  /**
   * Perform pop-dom-mount operations like listening for scroll and resize
   */


  /**
   * Set property defaults
   */


  _createClass(AppBar, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      // Set the window.load() event if specified in the props.
      if (this.props.resizeOnWindowLoad) {
        _Events2.default.on(window, 'load', this._onResize);
      }

      // Save the original top position of the menu
      if (this.outerCon) {
        this._onResize();
      }

      _Events2.default.on(window, 'scroll', this._onWindowScroll);
      _Events2.default.on(window, 'resize', this._onResize);
    }

    /**
     * Unregister all window listeners
     */

  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      _Events2.default.off(window, 'scroll', this._onWindowScroll);
      _Events2.default.off(window, 'resize', this._onResize);

      if (this.props.resizeOnWindowLoad) {
        _Events2.default.off(window, 'load', this._onResize);
      }
    }

    /**
     * Redner the component
     */

  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var classes = this.props.classes.appBar,
          elementCenter = void 0,
          menuElementLeft = void 0,
          menuElementRight = void 0;

      // Add color scheme
      classes += ' ' + this.props.classes.primary;

      if (this.props.className) {
        classes += ' ' + this.props.className;
      }

      // Set the left elements
      if (this.props.iconElementLeft) {
        // Add any appBar custom styles to the icon
        var iconElementLeft = this.props.iconElementLeft;
        menuElementLeft = _react2.default.createElement(
          'div',
          { className: this.props.classes.innerLeftContainer },
          iconElementLeft
        );
      }

      // If right elements exists, wrap in a toolbar
      if (this.props.iconElementRight) {
        menuElementRight = _react2.default.createElement(
          _AppBarRightToolbar2.default,
          null,
          this.props.iconElementRight
        );
      }

      // Add main content which is normally the title
      if (this.props.title) {
        // If the title is a string, wrap in an h1 tag.
        // If not, just use it as a node.
        elementCenter = toString.call(this.props.title) === '[object String]' ? _react2.default.createElement(
          'div',
          { className: this.props.classes.innerCenterContainer },
          this.props.title
        ) : this.props.title;
      } else if (this.props.children) {
        elementCenter = _react2.default.createElement(
          'div',
          { className: this.props.classes.innerCenterContainer },
          this.props.children
        );
      }

      // Get the zDepth passed - we may increment if we are floating
      var zDepth = this.props.zDepth;

      // Handle offset when the document scrolls and the appbar is fixed
      var innerConStyle = null;
      if (this.props.fixed) {
        innerConStyle = {
          position: 'fixed',
          width: this.state.startWidth,
          zIndex: 5
        };
      } else if (this.props.alwaysVisible && this.state.curTopOffset !== -1) {
        innerConStyle = {
          top: this.state.curTopOffset + 'px',
          width: this.state.startWidth,
          position: 'fixed',
          zIndex: 5
        };
      }

      return _react2.default.createElement(
        'div',
        {
          ref: function ref(outerCon) {
            _this2.outerCon = outerCon;
          },
          className: this.props.classes.outerContainer
        },
        _react2.default.createElement(
          'div',
          { style: innerConStyle },
          _react2.default.createElement(
            _Paper2.default,
            { rounded: false, className: classes, zDepth: zDepth },
            menuElementLeft,
            elementCenter,
            menuElementRight
          )
        )
      );
    }

    /**
     * Handle when the document is scrolled while the
     * The starting top of this menu was not 0 so it means
     * the menu is a fixed position and docked. A menu can be docked
     * below the top of the page (like below an AppBar) so we
     * want to be able to reposition the leftnav when the user scrolls
     * so it scrolls with the document until 0 (top)
     */


    /**
     * Handle resize events
     */

  }]);

  return AppBar;
}(_react.Component);

// Wrap in JSS for styles
//export default injectSheet(styles)(AppBar);


AppBar.propTypes = {
  /**
   * Custom classname
   */
  className: _propTypes2.default.string,

  /**
   * JSS classes for styling the component
   */
  classes: _propTypes2.default.object,

  /**
   * Icon element to show on the left
   */
  iconElementLeft: _propTypes2.default.element,

  /**
   * Icon element or elements to show on the right
   */
  iconElementRight: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.array]),

  /**
   * The main title of the AppBar
   */
  title: _propTypes2.default.node,

  /**
   * Optional custom z-depth
   */
  zDepth: _propTypes2.default.number,

  /**
   * AppBaR will always remain at the top of the page on scroll
   *
   * Fixed will override this option if both are true
   */
  alwaysVisible: _propTypes2.default.bool,

  /**
   * AppBaR is in a fixed location
   */
  fixed: _propTypes2.default.bool,

  /**
   * Optional. Set this flag if we want to resize the toolbar on window.load() event.
   */
  resizeOnWindowLoad: _propTypes2.default.bool
};
AppBar.defaultProps = {
  title: '',
  zDepth: 1,
  alwaysVisible: false,
  fixed: false
};
exports.default = (0, _injectStyles2.default)(_styles.styles, AppBar);
module.exports = exports['default'];