'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _SelectButton = require('../Picker/SelectButton');

var _SelectButton2 = _interopRequireDefault(_SelectButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/**
 * Wrapper for an SelectButton in the AppBar
 *
 * @param props
 * @returns {ReactDOM}
 */
var AppBarSelectButton = function AppBarSelectButton(props) {
  // Get className and children, and put the rest in other to forward below
  var className = props.className,
      children = props.children,
      other = _objectWithoutProperties(props, ['className', 'children']);

  // TODO: If we need to add a class to the button we can do it here

  return _react2.default.createElement(
    _SelectButton2.default,
    _extends({ className: className }, other),
    children
  );
};

/**
 * Set accepted properties
 */
AppBarSelectButton.propTypes = {
  /**
   * Optional class override
   */
  className: _propTypes2.default.string,

  /**
   * Child elements (text and icon)
   */
  children: _propTypes2.default.node
};

/**
 * Set property defaults
 */
AppBarSelectButton.defaultProps = {
  className: '',
  children: null
};

exports.default = AppBarSelectButton;
module.exports = exports['default'];