'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = exports.styles = function styles(theme) {
  var _outerContainer, _appBar, _innerCenterContainer;

  return {
    outerContainer: (_outerContainer = {
      height: theme.appBar.heightSmall
    }, _defineProperty(_outerContainer, '@media screen and (min-width: ' + theme.breakpoints.medium + 'px)}', {
      height: theme.appBar.heightMedium
    }), _defineProperty(_outerContainer, '@media screen and (min-width: ' + theme.breakpoints.large + 'px)}', {
      height: theme.appBar.heightLarge
    }), _outerContainer),
    appBar: (_appBar = {
      width: '100%',
      boxSizing: 'border-box',
      display: 'flex',
      flexDirection: 'row',
      flexWrap: 'nowrap',
      alignItems: 'center',
      // Default to small devices
      height: theme.appBar.heightSmall
    }, _defineProperty(_appBar, '@media screen and (min-width: ' + theme.breakpoints.medium + 'px)}', {
      height: theme.appBar.heightMedium
    }), _defineProperty(_appBar, '@media screen and (min-width: ' + theme.breakpoints.large + 'px)}', {
      height: theme.appBar.heightLarge
    }), _appBar),
    primary: {
      backgroundColor: theme.appBar.backgroundColor,
      color: theme.appBar.textColor
    },
    innerLeftContainer: _defineProperty({
      flexBasis: 'auto',
      flexGrow: 0,
      flexShrink: 1,
      // An icon button is 2x iconSize which provides a padding of 1/2 iconSize
      marginLeft: theme.gutters.small - theme.defaultIconSize / 2 + 'px',
      marginRight: theme.gutters.small - theme.defaultIconSize / 2 + 'px'
    }, '@media screen and (min-width: ' + theme.breakpoints.medium + 'px)}', {
      marginRight: theme.gutters.medium - theme.defaultIconSize / 2 + 'px',
      marginLeft: theme.gutters.medium - theme.defaultIconSize / 2 + 'px'
    }),
    innerCenterContainer: (_innerCenterContainer = {
      padding: theme.appBar.centerConPadding,
      margin: 0,
      flexBasis: 'auto',
      flexGrow: 1,
      flexShrink: 1,
      whiteSpace: 'nowrap',
      fontFamily: theme.font.fontFamily,
      lineHeight: theme.appBar.heightSmall,
      fontSize: theme.appBar.title.fontSize,
      fontWeight: theme.appBar.title.fontWeight,
      textAlign: theme.appBar.title.textAlign
    }, _defineProperty(_innerCenterContainer, '@media screen and (min-width: ' + theme.breakpoints.medium + 'px)}', {
      lineHeight: theme.appBar.heightMedium
    }), _defineProperty(_innerCenterContainer, '@media screen and (min-width: ' + theme.breakpoints.large + 'px)}', {
      lineHeight: theme.appBar.heightLarge
    }), _innerCenterContainer),
    innerRightContainer: {
      display: 'inline-block'
    }
  };
};