'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactTestRenderer = require('react-test-renderer');

var _reactTestRenderer2 = _interopRequireDefault(_reactTestRenderer);

var _Avatar = require('../Avatar');

var _Avatar2 = _interopRequireDefault(_Avatar);

var _EmailIcon = require('../../icons/svg/EmailIcon');

var _EmailIcon2 = _interopRequireDefault(_EmailIcon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('Avatar/Avatar', function () {
  // Basic validation that render works in edit mode and returns children
  it('Should render', function () {
    var renderer = _reactTestRenderer2.default.create(_react2.default.createElement(_Avatar2.default, null));
    var testInstance = renderer.root;
    expect(testInstance.findByType(_Avatar2.default)).not.toBeNull();
  });

  it('Should render with image', function () {
    var renderer = _reactTestRenderer2.default.create(_react2.default.createElement(_Avatar2.default, { src: 'notfound.png' }));
    var testInstance = renderer.root;
    expect(testInstance.findByType(_Avatar2.default)).not.toBeNull();
  });

  it('Should render with icon', function () {
    var renderer = _reactTestRenderer2.default.create(_react2.default.createElement(_Avatar2.default, { icon: _react2.default.createElement(_EmailIcon2.default, null) }));
    var testInstance = renderer.root;
    expect(testInstance.findByType(_Avatar2.default)).not.toBeNull();
  });

  it('Should render with icon letters', function () {
    var renderer = _reactTestRenderer2.default.create(_react2.default.createElement(_Avatar2.default, { iconLetters: 'A' }));
    var testInstance = renderer.root;
    expect(testInstance.findByType(_Avatar2.default)).not.toBeNull();
  });
});