'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var styles = exports.styles = function styles(theme) {
  return {
    dialog: {
      position: 'fixed',
      zIndex: 300,
      top: 0,
      left: '-100%',
      width: '100%',
      height: '100%',
      boxSizing: 'border-box',
      transition: theme.dialog.transition
    },

    dialogIsShown: {
      transition: theme.dialog.windowTransform,
      left: 0
    },

    dialogWindowInside: {
      opacity: '1 !important',
      top: 0,
      transform: theme.dialog.windowTransform
    },

    /**
     * A full page version of a dialog
     */
    dialogPage: {
      height: '100%',
      width: '100%',
      overflow: 'auto',
      zIndex: 300,
      backgroundColor: 'white',
      opacity: 1,
      position: 'absolute'
    },

    /**
     * The window for the dialog
     */
    dialogWindow: {
      transition: theme.dialog.windowTransformEaseOut,
      position: 'relative',
      width: '75%',
      maxWidth: theme.dialog.maxWidth,
      margin: '0 auto',
      zIndex: 300,
      background: theme.dialog.canvasColor,
      opacity: 0,
      boxSizing: 'border-box'
    },

    dialogWindowFullPage: {
      width: '100%',
      maxWidth: '100%',
      height: '100%',
      top: 0,
      display: 'grid',
      opacity: 1
    },

    dialogWindowTitle: {
      padding: theme.gutters.medium + 'px ' + theme.gutters.medium + 'px 0 ' + theme.gutters.medium + 'px',
      marginBottom: 0,
      boxSizing: 'border-box'
    },

    dialogWindowBody: {
      overflowY: 'auto',
      overflowX: 'hidden',
      margin: theme.gutters.medium + 'px'
    },

    dialogWindowActions: {
      padding: '8px',
      marginBottom: '8px',
      width: '100%',
      textAlign: 'right',
      boxSizing: 'border-box'
    },

    dialogWindowAction: {
      marginRight: '8px'
    }
  };
};