'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _EditorToolbar = require('./EditorToolbar');

var _EditorToolbar2 = _interopRequireDefault(_EditorToolbar);

var _reactCodemirror = require('react-codemirror2');

var _styles = require('./styles');

var _injectStyles = require('../styles/injectStyles');

var _injectStyles2 = _interopRequireDefault(_injectStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Contains codemirror and the toolbar for viewing source
 */
var ContentSource = function (_Component) {
  _inherits(ContentSource, _Component);

  /**
   * Class constructor
   *
   * @param {Object} props Properties to send to the render function
   */
  function ContentSource(props) {
    _classCallCheck(this, ContentSource);

    var _this = _possibleConstructorReturn(this, (ContentSource.__proto__ || Object.getPrototypeOf(ContentSource)).call(this, props));
    // Call parent constructor


    _this._onChange = function (editor, data, value) {
      if (_this.props.onChange) {
        _this.props.onChange(value);
      }

      _this.setState({ value: value });
    };

    _this._handleContentViewToggle = function (contentView) {
      if (_this.props.onContentViewToggle) {
        _this.props.onContentViewToggle(contentView, _this.state.value);
      }
    };

    _this.state = {
      value: _this.props.value,
      mountedInDom: false
    };
    return _this;
  }

  /**
   * Handle when the editor has changed
   *
   * @param {Editor} editor The codemirror editor instnace
   * @param {Object} data Data about the change?
   * @param {string} value The value of the editor
   * @private
   */

  /**
   * Set accepted properties
   */


  /**
   * Handles the toggling of content view
   *
   * @param {int} contentView The content view we are switching to
   * @private
   */


  _createClass(ContentSource, [{
    key: 'componentWillReceiveProps',


    /**
     * Update the value if changed
     *
     * @param {Object} props
     */
    value: function componentWillReceiveProps(props) {
      if (this.state.value != props.value) {
        this.setState({ value: props.value });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var options = {
        lineNumbers: true,
        mode: 'htmlmixed'
      };

      return _react2.default.createElement(
        'div',
        { className: this.props.richTextContainer },
        _react2.default.createElement(_EditorToolbar2.default, {
          contentViewType: this.props.contentViewType,
          onContentViewToggle: this._handleContentViewToggle
        }),
        _react2.default.createElement(_reactCodemirror.Controlled, { value: this.state.value, onBeforeChange: this._onChange, options: options })
      );
    }
  }]);

  return ContentSource;
}(_react.Component);

// Wrap in JSS for styles


ContentSource.propTypes = {
  /**
   * The callback function used when user changes the content of the editor
   *
   * @type {function}
   */
  onChange: _propTypes2.default.func,

  /**
   * The callback function used when user looses the focus of the editor
   *
   * @type {function}
   */
  onBlur: _propTypes2.default.func,

  /**
   * The initial value of the content editor
   *
   * @type {string}
   */
  value: _propTypes2.default.string,

  /**
   * Handles the toggling of content view
   *
   * @type {function}
   */
  onContentViewToggle: _propTypes2.default.func
};
exports.default = (0, _injectStyles2.default)(_styles.styles, ContentSource);
module.exports = exports['default'];