'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _styles = require('./styles');

var _injectStyles = require('../styles/injectStyles');

var _injectStyles2 = _interopRequireDefault(_injectStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/**
 * Functional component for any button
 *
 * @param props
 * @param context
 * @returns {ReactDOM}
 * @constructor
 */
var FontIcon = function FontIcon(props, context) {
  var _classnames;

  var className = props.className,
      classes = props.classes,
      other = _objectWithoutProperties(props, ['className', 'classes']);

  var classNames = (0, _classnames3.default)(classes.fontIcon, (_classnames = {}, _defineProperty(_classnames, classes.iconSize18, props.size == 18), _defineProperty(_classnames, classes.iconSize24, props.size == 24), _defineProperty(_classnames, classes.iconSize36, props.size == 36), _defineProperty(_classnames, classes.iconSize48, props.size == 48), _classnames), className);

  // TODO: Set the material for now as default
  var themeName = 'material';
  var content = themeName === 'material' ? props.children : null;

  return _react2.default.createElement(
    'span',
    _extends({ className: classNames }, other),
    content
  );
};

/**
 * Set accepted properties
 */
FontIcon.propTypes = {
  className: _propTypes2.default.string,
  size: _propTypes2.default.oneOf([18, 24, 36, 48])
};

/**
 * Set property defaults
 */
FontIcon.defaultProps = {
  className: '',
  size: 24
};

// Wrap in JSS for styles
exports.default = (0, _injectStyles2.default)(_styles.styles, FontIcon);
module.exports = exports['default'];