'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _styles = require('./styles');

var _injectStyles = require('../styles/injectStyles');

var _injectStyles2 = _interopRequireDefault(_injectStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Grid column
 *
 * @param props
 * @param context
 * @returns {ReactDOM}
 * @constructor
 */
var Column = function Column(props, context) {
  var _classnames;

  var propsClasses = props.classes;

  var classes = (0, _classnames3.default)(propsClasses.column, (_classnames = {}, _defineProperty(_classnames, propsClasses['colXSmall' + props.xsmall], props.xsmall), _defineProperty(_classnames, propsClasses['colSmall' + props.small], props.small), _defineProperty(_classnames, propsClasses['colMedium' + props.medium], props.medium), _defineProperty(_classnames, propsClasses['colLarge' + props.large], props.large), _defineProperty(_classnames, propsClasses['colXLarge' + props.xlarge], props.xlarge), _classnames));

  return _react2.default.createElement(
    'div',
    { className: classes, style: props.style },
    props.children
  );
};

/**
 * Set accepted properties
 */
Column.propTypes = {
  xsmall: _propTypes2.default.number,
  small: _propTypes2.default.number,
  medium: _propTypes2.default.number,
  large: _propTypes2.default.number,
  xlarge: _propTypes2.default.number,
  children: _propTypes2.default.node,
  style: _propTypes2.default.object
};

// Wrap in JSS for styles
exports.default = (0, _injectStyles2.default)(_styles.styles, Column);
module.exports = exports['default'];