'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _styles = require('./styles');

var _injectStyles = require('../styles/injectStyles');

var _injectStyles2 = _interopRequireDefault(_injectStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Grid row
 *
 * @param props
 * @param context
 * @returns {ReactDOM}
 * @constructor
 */
var Container = function Container(props, context) {
  var _classnames;

  var classes = (0, _classnames3.default)(props.classes.container, (_classnames = {}, _defineProperty(_classnames, props.classes.containerCentered, props.centered), _defineProperty(_classnames, props.classes.containerNoGutter, props.nogutter), _classnames));

  return _react2.default.createElement(
    'div',
    { className: classes },
    props.children
  );
};

/**
 * Set accepted properties
 */
Container.propTypes = {
  /**
   * Child nodes to render
   * @ignore
   */
  children: _propTypes2.default.node,

  /**
   * If true the remove gutters from the container
   */
  nogutter: _propTypes2.default.bool,

  /**
   * Main centered contianer used for centering a full page
   */
  centered: _propTypes2.default.bool
};

Container.defaultProps = {
  nogutter: false,
  centered: false
};

// Wrap in JSS for styles
exports.default = (0, _injectStyles2.default)(_styles.styles, Container);
module.exports = exports['default'];