'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('./styles');

var _injectStyles = require('../styles/injectStyles');

var _injectStyles2 = _interopRequireDefault(_injectStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Show a divider (hr) on a page - usually used inside a grid but not required
 *
 * @param {Object} props
 * @returns {ReactDOM}
 */
var DividerHoriz = function DividerHoriz(props) {
  var styles = props.marginsVert ? { marginTop: props.marginsVert, marginBottom: props.marginsVert } : null;
  return _react2.default.createElement('div', { style: styles, className: props.classes.dividerHoriz });
};

/**
 * Set accepted properties
 */
DividerHoriz.propTypes = {
  /**
   * Optional margin above and below the line
   */
  marginsVert: _propTypes2.default.number,

  /**
   * JSS classes for styling the component
   */
  classes: _propTypes2.default.object
};

exports.default = (0, _injectStyles2.default)(_styles.styles, DividerHoriz);
module.exports = exports['default'];