'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.styles = undefined;

var _simpleAssign = require('simple-assign');

var _simpleAssign2 = _interopRequireDefault(_simpleAssign);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = exports.styles = function styles(theme) {
  var _objectAssign2, _objectAssign3;

  var mediaMedium = '@media (min-width: ' + theme.breakpoints.medium + 'px)';
  var mediaLarge = '@media (min-width: ' + theme.breakpoints.large + 'px)';
  var mediaxLarge = '@media (min-width: ' + theme.breakpoints.xLarge + 'px)';

  var styleBeforeAfter = {
    '&:before': {
      content: '" "',
      display: 'table'
    },
    '&:after': {
      content: '" "',
      display: 'table',
      clear: 'both'
    }
  };

  var gridObject = {
    container: (0, _simpleAssign2.default)({}, styleBeforeAfter, (_objectAssign2 = {
      marginRight: 'auto',
      marginLeft: 'auto',
      paddingLeft: theme.gutters.small + 'px',
      paddingRight: theme.gutters.small + 'px',
      boxSizing: 'border-box'
    }, _defineProperty(_objectAssign2, mediaMedium, { width: '750px' }), _defineProperty(_objectAssign2, mediaLarge, { width: '970px' }), _defineProperty(_objectAssign2, mediaxLarge, { width: '1170px' }), _objectAssign2)),

    containerFluid: (0, _simpleAssign2.default)({}, styleBeforeAfter, {
      marginRight: 'auto',
      marginLeft: 'auto',
      paddingLeft: theme.gutters.small + 'px',
      paddingRight: theme.gutters.small + 'px',
      boxSizing: 'border-box'
    }),

    row: (0, _simpleAssign2.default)({}, styleBeforeAfter, {
      marginLeft: '-' + theme.gutters.small + 'px',
      marginRight: '-' + theme.gutters.small + 'px',
      boxSizing: 'border-box'
    }),

    clearfix: styleBeforeAfter,

    centerBlock: {
      display: 'block',
      marginLeft: 'auto',
      marginRight: 'auto'
    },

    Pullright: {
      float: 'right !important'
    },

    Pullleft: {
      float: 'left !important'
    },

    hide: {
      display: 'none !important'
    },

    show: {
      display: 'block !important'
    },

    invisible: {
      visibility: 'hidden'
    },

    textHide: {
      font: '0/0 a',
      color: 'transparent',
      textShadow: 'none',
      'background-color': 'transparent',
      border: 0
    },

    hidden: {
      display: 'none !important'
    },

    affix: {
      position: 'fixed'
    }
  };

  var columnStyle = {
    position: 'relative',
    minHeight: '1px',
    paddingLeft: theme.gutters.small + 'px',
    paddingRight: theme.gutters.small + 'px',
    boxSizing: 'border-box'
  };

  var colStyleValues = {
    '12': '100%',
    '11': '91.66666667%',
    '10': '83.33333333%',
    '9': '75%',
    '8': '66.66666667%',
    '7': '58.33333333%',
    '6': '50%',
    '5': '41.66666667%',
    '4': '33.33333333%',
    '3': '25%',
    '2': '16.66666667%',
    '1': '8.33333333%',
    '0': 'auto'
  };

  var colMedium = {};
  var colLarge = {};
  var colxLarge = {};

  /*
     * The Grid can be divided into a maximum of 12 columns.
     * We need to loop here 12 times to assign the specific width of each column
     */
  for (var idx = 0; idx <= 12; idx++) {
    var marginLeft = colStyleValues[idx];

    // We will be assigning styles here for the Grid Column 1 to 12
    if (idx > 0) {
      gridObject['colSmall' + idx] = (0, _simpleAssign2.default)({}, columnStyle, {
        float: 'left',
        width: colStyleValues[idx]
      });
      gridObject['colMedium' + idx] = columnStyle;
      gridObject['colLarge' + idx] = columnStyle;
      gridObject['colXLarge' + idx] = columnStyle;

      colMedium['colMedium' + idx] = { float: 'left', width: colStyleValues[idx] };
      colLarge['colLarge' + idx] = { float: 'left', width: colStyleValues[idx] };
      colxLarge['colXLarge' + idx] = { float: 'left', width: colStyleValues[idx] };
    }

    // We will set the styles for pull/push/offset for columns when displaying in small devices
    gridObject['colSmallPull' + idx] = { right: colStyleValues[idx] };
    gridObject['colSmallPush' + idx] = { left: colStyleValues[idx] };
    gridObject['colSmalloffset-' + idx] = { marginLeft: marginLeft };

    // We will set the styles for pull/push/offset for columns when displaying in mediumn devices
    colMedium['colMediumPull' + idx] = { right: colStyleValues[idx] };
    colMedium['colMediumPush' + idx] = { left: colStyleValues[idx] };
    colMedium['colMediumoffset-' + idx] = { marginLeft: marginLeft };

    // We will set the styles for pull/push/offset for columns when displaying in large devices
    colLarge['colLargePull' + idx] = { right: colStyleValues[idx] };
    colLarge['colLargePush' + idx] = { left: colStyleValues[idx] };
    colLarge['colLargeoffset-' + idx] = { marginLeft: marginLeft };

    // We will set the styles for pull/push/offset for columns when displaying in xLarge devices
    colxLarge['colXLargePull' + idx] = { right: colStyleValues[idx] };
    colxLarge['colXLargePush' + idx] = { left: colStyleValues[idx] };
    colxLarge['colXLargeoffset-' + idx] = { marginLeft: marginLeft };
  }

  // Merge the styles for pull/push/offset (medium, large and xLarge devices)
  gridObject = (0, _simpleAssign2.default)({}, gridObject, (_objectAssign3 = {}, _defineProperty(_objectAssign3, mediaMedium, colMedium), _defineProperty(_objectAssign3, mediaLarge, colLarge), _defineProperty(_objectAssign3, mediaxLarge, colxLarge), _objectAssign3));

  return gridObject;
};