'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _uaParserJs = require('ua-parser-js');

var _uaParserJs2 = _interopRequireDefault(_uaParserJs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var uaParser = new _uaParserJs2.default();

/**
 * This is used as a fallback to ./RichText because the edit-js library
 * used in the default RichText is not yet supported on Android or iOS.
 */

var RichTextIframe = function (_Component) {
  _inherits(RichTextIframe, _Component);

  /**
   * Class constructor
   *
   * @param {Object} props Properties to send to the render function
   */
  function RichTextIframe(props) {
    _classCallCheck(this, RichTextIframe);

    var _this = _possibleConstructorReturn(this, (RichTextIframe.__proto__ || Object.getPrototypeOf(RichTextIframe)).call(this, props));
    // Call parent constructor


    _this._getIframeWindow = function () {
      var ifrm = _reactDom2.default.findDOMNode(_this.rte);
      return ifrm.contentWindow || ifrm.contentDocument;
    };

    _this.clearValue = function () {
      _this.setValue('');
    };

    _this.getValue = function () {
      var ifrmWindow = _this._getIframeWindow();
      var idoc = ifrmWindow.document || null;
      var value = idoc.body.innerHTML || '';

      return value;
    };

    _this.setValue = function (newValue) {
      var ifrmWindow = _this._getIframeWindow();
      var idoc = ifrmWindow.document || null;

      if (idoc) {
        idoc.body.innerHTML = newValue;
        _this._autoGrow();
      }
    };

    _this._setRange = function () {
      var ifrmWindow = _this._getIframeWindow();
      var idoc = ifrmWindow.document || null;

      if (idoc && uaParser.getBrowser().name == 'IE') {
        var selection = idoc.selection;
        if (selection != null) _this._rangeSelection = selection.createRange();
      } else if (ifrmWindow) {
        var _selection = ifrmWindow.getSelection();
        _this._rangeSelection = _selection.getRangeAt(_selection.rangeCount - 1).cloneRange();
      }

      if (ifrmWindow && idoc && uaParser.getBrowser().name == 'IE') {
        ifrmWindow.focus();

        // retrieve selected range
        var sel = idoc.selection;
        if (sel != null) {
          var newRng = sel.createRange();
          newRng = _this._rangeSelection;
          newRng.select();
        }
      }
    };

    _this._handleInputBlur = function (e) {
      if (_this.props.onBlur) {
        _this.props.onBlur(_this.getValue());
      }
    };

    _this._handleInputChange = function (e) {
      if (_this.props.onChange) {
        _this.props.onChange(_this.getValue());
      }
    };

    _this._handleInputFocus = function (e) {
      if (_this.props.onFocus) {
        _this.props.onFocus(_this.getValue());
      }
    };

    _this._handleInputKeyUp = function (e) {
      var result = _this.getValue();

      if (_this.props.autoGrow) {
        _this._autoGrow();
      }

      if (e.keyCode == 13 && _this.props.onEnterKeyDown) {
        _this.props.onEnterKeyDown(result);
      }

      // Handle onkeydown event
      if (_this.props.onKeyUp) {
        _this.props.onKeyUp(result);
      }

      // Handle onChange event
      if (_this.props.onChange) {
        _this.props.onChange(result);
      }
    };

    _this._handleTextAreaHeightChange = function (e, height) {
      var newHeight = height + 24;
      if (_this.props.floatingLabelText) {
        newHeight += 24;
      }
      _reactDom2.default.findDOMNode(_this).style.height = newHeight + 'px';
    };

    _this._enableDesign = function (on) {
      // Only enable after mounted into the dom

      // Get the iframe document
      var ifrmWindow = _this._getIframeWindow();
      var idoc = ifrmWindow.document || null;

      // Make sure document is defined
      if (!idoc) {
        throw 'Could not get the document of the iframe';
      }

      var designModeOn = on || true;

      var editorBody = idoc.body;

      // Turn on spellcheck if available
      if ('spellcheck' in editorBody && designModeOn) {
        editorBody.spellcheck = true;
      }

      // Make content editable
      if ('contentEditable' in editorBody && designModeOn) {
        editorBody.contentEditable = true;
      } else {
        // Firefox earlier than version 3 uses document rather than body
        if ('designMode' in idoc && designModeOn) {
          idoc.designMode = 'on';
        }
      }

      // Set document events
      var evtObj = uaParser.getBrowser().name == 'IE' ? _reactDom2.default.findDOMNode(_this.rte) : _this._getIframeWindow();

      if (evtObj.addEventListener) {
        // W3C DOM

        // on blur
        evtObj.addEventListener('blur', function (evt) {
          this._handleInputBlur(evt);
        }.bind(_this), false);

        // on keyup
        evtObj.addEventListener('keyup', function (evt) {
          this._handleInputKeyUp(evt);
        }.bind(_this), false);

        // on focus
        evtObj.addEventListener('focus', function (evt) {
          this._handleInputFocus(evt);
        }.bind(_this), false);
      } else if (evtObj.attachEvent) {
        // IE DOM

        // on blur
        evtObj.attachEvent('onblur', function (evt) {
          this._handleInputBlur(evt);
        }.bind(_this));

        // on keydown
        evtObj.attachEvent('onkeyup', function (evt) {
          this._handleInputKeyUp(evt);
        }.bind(_this));

        // on focus
        evtObj.attachEvent('onfocus', function (evt) {
          this._handleInputFocus(evt);
        }.bind(_this));
      }

      return true;
    };

    _this._autoGrow = function () {
      var ifrmWindow = _this._getIframeWindow();
      var idoc = ifrmWindow.document || null;

      if (idoc) {
        var contentHeight = idoc.body.scrollHeight;

        var iframe = _reactDom2.default.findDOMNode(_this.rte);
        iframe.style.height = contentHeight + 'px';
      }
    };

    _this.sendCommand = function (command, option) {
      try {
        var ifrmWindow = _this._getIframeWindow();
        var idoc = ifrmWindow.document || null;

        if (idoc) {
          ifrmWindow.focus();
          idoc.execCommand(command, false, option);
          ifrmWindow.focus();

          // After executing the command, we need to clear the command to prepare for the next command
          _this.props.onToggle(_this.getValue());
        }
      } catch (e) {
        throw new Error('Error while executing the ' + command + ' command');
      }
    };

    _this.rte = null;
    return _this;
  }

  _createClass(RichTextIframe, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.rte) {
        var iframe = _reactDom2.default.findDOMNode(this.rte);
        iframe.style.width = '100%';

        // If height has been passed then set the iframe height
        if (this.props.height) {
          iframe.style.height = height + 'px';
        }
      }

      this._enableDesign(true);
      this.setValue(this.props.value);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(newProps) {
      var commandType = newProps.commandToggleType;

      // Check if command type is set, if so then we send the command to RTE
      if (commandType) {
        this.sendCommand(commandType, 'true');
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement('iframe', {
          ref: function ref(rte) {
            _this2.rte = rte;
          },
          frameborder: 0,
          src: 'about:blank'
        })
      );
    }

    /**
     * Get the iframe window document
     *
     * @private
     */


    /**
     * Clear the value of the iframe document
     *
     * @public
     */


    /**
     * Get the current value of the iframe document / code mirror editor
     *
     * @public
     */


    /**
     * Set the value of the iframe document / code mirror editor
     *
     * @param {string} newValue The value to be saved in the editor
     * @public
     */


    /**
     * Set the range of the iframe document
     *
     * @private
     */


    /**
     * Handles the input blur event of the text area
     *
     * @param {DOMEvent} e Reference to the DOM event being sent
     * @private
     */


    /**
     * Handles the input change event of the text area
     *
     * @param {DOMEvent} e Reference to the DOM event being sent
     * @private
     */


    /**
     * Handles the input focus of the text area
     *
     * @param {DOMEvent} e Reference to the DOM event being sent
     * @private
     */


    /**
     * Handles the input key down of the text area
     *
     * @param {DOMEvent} e        Reference to the DOM event being sent
     * @private
     */


    /**
     * Handles the change of height event of the text area
     *
     * @param {DOMEvent} e        Reference to the DOM event being sent
     * @param {int} height    T    The height to be set
     * @private
     */


    /**
     * Enables the editor if it is already mounted
     *
     * @private
     */


    /**
     * Autogrow the editor to match the contents
     *
     * @private
     */


    /**
     * Public interface to send commands to the RTE
     *
     * @param {string} command The name of the RTE command to execute
     * @param {string} option    The option when executing a certain command. e.g. changing the font/background colors
     * @public
     */

  }]);

  return RichTextIframe;
}(_react.Component);

RichTextIframe.propTypes = {
  id: _propTypes2.default.string,
  onBlur: _propTypes2.default.func,
  onChange: _propTypes2.default.func,
  onFocus: _propTypes2.default.func,
  onKeyUp: _propTypes2.default.func,
  onEnterKeyDown: _propTypes2.default.func,
  autoGrow: _propTypes2.default.bool,
  height: _propTypes2.default.number,
  value: _propTypes2.default.string
};

RichTextIframe.defaultProps = {
  autoGrow: true,
  value: ''
};

exports.default = RichTextIframe;
module.exports = exports['default'];