'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _styles = require('./styles');

var _injectStyles = require('../styles/injectStyles');

var _injectStyles2 = _interopRequireDefault(_injectStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Show a divider (hr) in a list
 *
 * @param props
 * @returns {ReactDOM}
 */
var ListDivider = function ListDivider(props) {
  var classes = (0, _classnames3.default)(props.classes.listDivider, _defineProperty({}, props.classes.listDividerInset, props.inset));

  return _react2.default.createElement('div', { className: classes });
};

/**
 * Set accepted properties
 */
ListDivider.propTypes = {
  /**
   * Optional flag that can be set to indicate this item is selected
   */
  inset: _propTypes2.default.bool,

  /**
   * JSS classes for styling the component
   */
  classes: _propTypes2.default.object
};

/**
 * Set property defaults
 */
ListDivider.defaultProps = {
  inset: false
};

exports.default = (0, _injectStyles2.default)(_styles.styles, ListDivider);
module.exports = exports['default'];