'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _styles = require('./styles');

var _injectStyles = require('../styles/injectStyles');

var _injectStyles2 = _interopRequireDefault(_injectStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Overlay = function (_Component) {
  _inherits(Overlay, _Component);

  function Overlay() {
    _classCallCheck(this, Overlay);

    return _possibleConstructorReturn(this, (Overlay.__proto__ || Object.getPrototypeOf(Overlay)).apply(this, arguments));
  }

  _createClass(Overlay, [{
    key: 'componentDidMount',

    /**
     * Set accepted properties
     */
    value: function componentDidMount() {
      this.setBodyOverflow();
    }

    /**
     * Set property defaults
     */

  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var OVERFLOW_AUTOMATIC = '';
      this.setBodyOverflow(OVERFLOW_AUTOMATIC);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.setBodyOverflow();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          other = _objectWithoutProperties(_props, ['className']),
          classes = (0, _classnames3.default)(this.props.classes.overlay, _defineProperty({}, this.props.classes.overlayVisible, this.props.show), className);

      return _react2.default.createElement('div', { className: classes, onClick: this.props.onClick });
    }

    /**
     * Function that will set the overflow the the html body
     *
     * @param {string} forceOverflowValue Optional. This will override the overflow value and will be set directly to body's overflow.
     */

  }, {
    key: 'setBodyOverflow',
    value: function setBodyOverflow(forceOverflowValue) {
      // We need to make sure that the document is mounted before we set the overflow
      if (document) {
        var body = document.getElementsByTagName('body')[0];
        var overflowValue = this.props.show ? 'hidden' : '';

        // if force overflow value is defined, then we will use it to set the body's overflow
        if (typeof forceOverflowValue !== "undefined") {
          overflowValue = forceOverflowValue;
        }

        body.style.overflow = overflowValue;
      }
    }
  }]);

  return Overlay;
}(_react.Component);

// Wrap in JSS for styles


Overlay.propTypes = {
  show: _propTypes2.default.bool,
  onClick: _propTypes2.default.func,

  /**
   * JSS classes
   */
  classes: _propTypes2.default.object
};
Overlay.defaultProps = {
  show: false
};
exports.default = (0, _injectStyles2.default)(_styles.styles, Overlay);
module.exports = exports['default'];