'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('./styles');

var _injectStyles = require('../styles/injectStyles');

var _injectStyles2 = _interopRequireDefault(_injectStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Paper is a concept taken from google Material design standards
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


/**
 * Small application component
 */
var Paper = function (_Component) {
  _inherits(Paper, _Component);

  function Paper() {
    _classCallCheck(this, Paper);

    return _possibleConstructorReturn(this, (Paper.__proto__ || Object.getPrototypeOf(Paper)).apply(this, arguments));
  }

  _createClass(Paper, [{
    key: 'componentDidMount',

    /**
     * Set accepted properties
     */
    value: function componentDidMount() {
      // Variables used for callback refs
      this.innerContainer = null;
    }

    /**
     * Set property defaults
     */

  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var propsClasses = this.props.classes;
      var classes = propsClasses.paper;

      if (this.props.className) {
        classes += ' ' + this.props.className;
      }

      classes += ' ' + propsClasses['paperZDepth' + this.props.zDepth];

      if (this.props.rounded) {
        classes += ' ' + propsClasses.paperRounded;
      }

      if (this.props.circle) {
        classes += ' ' + propsClasses.paperCircle;
      }

      var insideClasses = this.props.innerClassName + ' ' + propsClasses.paperContainer + ' ' + propsClasses['paperZDepth' + this.props.zDepth + 'Bottom'];

      return _react2.default.createElement(
        'div',
        {
          className: classes,
          style: this.props.style,
          ref: function ref(innerContainer) {
            _this2.innerContainer = innerContainer;
          }
        },
        this.props.children
      );
    }
  }, {
    key: 'getInnerContainer',
    value: function getInnerContainer() {
      return this.innerContainer;
    }
  }]);

  return Paper;
}(_react.Component);

// Wrap in JSS for styles


Paper.propTypes = {
  circle: _propTypes2.default.bool,
  innerClassName: _propTypes2.default.string,
  rounded: _propTypes2.default.bool,
  style: _propTypes2.default.object,
  zDepth: _propTypes2.default.oneOf([0, 1, 2, 3, 4, 5])
};
Paper.defaultProps = {
  innerClassName: '',
  rounded: true,
  zDepth: 1,
  style: null
};
exports.default = (0, _injectStyles2.default)(_styles.styles, Paper);
module.exports = exports['default'];