'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _DateTime = require('../utils/DateTime');

var _DateTime2 = _interopRequireDefault(_DateTime);

var _TextField = require('../Input/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _device = require('../utils/device');

var _device2 = _interopRequireDefault(_device);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DatePicker = function (_Component) {
  _inherits(DatePicker, _Component);

  /**
   * Class constructor takes properties and passes them to the parent/super
   */
  function DatePicker(props) {
    _classCallCheck(this, DatePicker);

    var _this = _possibleConstructorReturn(this, (DatePicker.__proto__ || Object.getPrototypeOf(DatePicker)).call(this, props));

    _this._handleInputChange = function (e) {
      var dateString = e.target.value;
      var d = null;

      /*
       * HTML5 date inputs return yyyy-mm-dd which will be parsed as UTC
       * since javascript treates all iso standards as UTC and non-standard
       * dates like mm/dd/yyyy as local (PUKE). This is changing in EMCA 2015
       * but for now we need to offset the local from UTC to make sure we use the
       * actual date the user selected
       */
      if (dateString) {
        var parts = dateString.split('-');
        // new Date(year, month [, day [, hours[, minutes[, seconds[, ms]]]]])

        // Make a local date with the date parts
        d = new Date(parts[0], parts[1] - 1, parts[2]); // Note: months are 0-based
      }

      if (_this.props.onChange) {
        _this.props.onChange(null, d);
      }
    };

    _this._handleInputFocus = function (e) {
      e.target.blur();
      if (_this.props.onFocus) {
        _this.props.onFocus(e);
      }
    };

    _this.state = {
      date: _this.props.defaultDate,
      dialogDate: new Date()
    };
    return _this;
  }
  /**
   * Property types we handle
   */


  _createClass(DatePicker, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          value = _props.value,
          onChange = _props.onChange,
          onFocus = _props.onFocus,
          other = _objectWithoutProperties(_props, ['value', 'onChange', 'onFocus']);

      // Check value


      var dateValue = null;
      if (this.props.value) {
        if (this.props.value instanceof Date) {
          dateValue = _DateTime2.default.format(this.props.value);
        } else if (this.props.value === 'now') {
          dateValue = _DateTime2.default.format(new Date());
        } else {
          dateValue = this.props.value;
        }
      }

      return _react2.default.createElement(_TextField2.default, _extends({}, other, {
        onChange: this._handleInputChange,
        type: 'date',
        value: dateValue,
        onFocus: this._handleInputFocus,
        onClick: this._handleInputTouchTap
      }));
    }

    /**
     * Handle native date input change
     */

  }]);

  return DatePicker;
}(_react.Component);

DatePicker.propTypes = {
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.instanceOf(Date)]),
  onFocus: _propTypes2.default.func,
  onChange: _propTypes2.default.func
};
exports.default = DatePicker;
module.exports = exports['default'];