'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _ArrowDropDownIcon = require('../icons/svg/ArrowDropDownIcon');

var _ArrowDropDownIcon2 = _interopRequireDefault(_ArrowDropDownIcon);

var _Menu = require('../Menu/Menu');

var _Menu2 = _interopRequireDefault(_Menu);

var _Popover = require('../Popover/Popover');

var _Popover2 = _interopRequireDefault(_Popover);

var _FontIcon = require('../FontIcon');

var _FontIcon2 = _interopRequireDefault(_FontIcon);

var _IconButton = require('../Button/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _styles = require('./styles');

var _injectStyles = require('../styles/injectStyles');

var _injectStyles2 = _interopRequireDefault(_injectStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Component for displaying dropdowns
 */
var SelectButton = function (_Component) {
  _inherits(SelectButton, _Component);

  /**
   * Class constructor takes properties and passes them to the parent/super
   */
  function SelectButton(props) {
    _classCallCheck(this, SelectButton);

    // Popover anchor element
    var _this = _possibleConstructorReturn(this, (SelectButton.__proto__ || Object.getPrototypeOf(SelectButton)).call(this, props));

    _initialiseProps.call(_this);

    _this.popoverAncherEl = _react2.default.createRef();

    _this.state = {
      open: false,
      selectedIndex: props.selectedIndex || 0
    };
    return _this;
  }

  /**
   * Popover has entered the dom
   */


  _createClass(SelectButton, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.props.hasOwnProperty('selectedIndex')) {
        this._setSelectedIndex(this.props);
      }
    }

    /**
     * Componenent is about to exit the dom
     */

  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this.props.hasOwnProperty('selectedIndex')) {
        this._setSelectedIndex(nextProps);
      }
    }

    /**
     * Render Componenent
     */

  }, {
    key: 'render',
    value: function render() {
      // Use default dropdown icon
      var icon = _react2.default.createElement(_ArrowDropDownIcon2.default, null);

      if (this.props.icon) {
        icon = typeof this.props.icon === 'string' ? _react2.default.createElement(_FontIcon2.default, { className: this.props.icon }) : this.props.icon;
      }

      var className = (0, _classnames2.default)(this.props.classes.selectButtonCon, this.props.className);

      return _react2.default.createElement(
        'div',
        { className: className },
        _react2.default.createElement(
          'div',
          { style: { align: 'top' }, ref: this.popoverAncherEl },
          _react2.default.createElement(
            _IconButton2.default,
            { className: this.props.className, onTap: this._onControlClick },
            icon
          )
        ),
        _react2.default.createElement(
          _Popover2.default,
          {
            open: this.state.open,
            anchorEl: this.popoverAncherEl,
            anchorOrigin: { horizontal: 'left', vertical: 'top' },
            onRequestClose: this._handleRequestClose
          },
          _react2.default.createElement(
            _Menu2.default
            //ref="menuItems"
            ,
            { customClasses: this.props.classes[this.props.colorScheme],
              autoWidth: this.props.autoWidth,
              selectedIndex: this.state.selectedIndex,
              menuItems: this.props.menuItems,
              onItemClick: this._onMenuItemClick
            },
            this.props.children
          )
        )
      );
    }

    /**
     * Set which menu item is selected
     *
     * @private
     * @param {Object} props The props we are setting
     */


    /**
     * Meny control clicked handler
     *
     * @private
     * @param {DOMEvent} e The click event fired
     */


    /**
     * Triggered when a menu item gets clicked
     *
     * @private
     * @param {DOMEvent} e The event fired through
     * @param {int} key The index of the item clicked - this will be deprecated soon
     * @param {Object} payload Whatever payload was passed to the menu
     */


    /**
     * Handle when the popover gets closed
     *
     * @private
     * @param {DOMEvent} e The click event fired
     */

  }]);

  return SelectButton;
}(_react.Component);

/**
 * Set accepted properties
 */


var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this._setSelectedIndex = function (props) {
    var selectedIndex = props.selectedIndex;

    if (process.env.NODE_ENV !== 'production' && selectedIndex < 0) {
      console.warn('Cannot set selectedIndex to a negative index.', selectedIndex);
    }

    _this2.setState({ selectedIndex: selectedIndex > -1 ? selectedIndex : 0 });
  };

  this._onControlClick = function (e) {
    e.preventDefault();

    _this2.setState({
      open: !_this2.state.open
    });
  };

  this._onMenuItemClick = function (e, key, payload) {
    if (_this2.props.onChange) {
      _this2.props.onChange(e, key, payload);
    }

    _this2.setState({
      selectedIndex: key,
      open: false
    });

    // Prevent ghost clicks
    e.preventDefault();
    e.stopPropagation();

    // TODO: Not sure if this is needed with the above being called
    e.nativeEvent.stopImmediatePropagation();
  };

  this._handleRequestClose = function (e) {
    _this2.setState({
      open: false
    });
  };
};

SelectButton.propTypes = {
  onChange: _propTypes2.default.func,
  selectedIndex: _propTypes2.default.number,
  icon: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),
  menuItems: _propTypes2.default.array.isRequired,

  /**
   * Optional additional class for the icon button
   */
  className: _propTypes2.default.string,

  /**
   * Optional children can be used to define content
   */
  children: _propTypes2.default.node,

  /**
   * Optional color scheme to use
   *
   * dark = darker text color
   * light = light text color
   */
  txtColorScheme: _propTypes2.default.oneOf(['primary', 'dark', 'light'])
};

/**
 * Set property defaults
 */
SelectButton.defaultProps = {
  autoWidth: true,
  children: null,
  className: null,
  colorScheme: 'light'
};

// Wrap in JSS for styles
exports.default = (0, _injectStyles2.default)(_styles.styles, SelectButton);
module.exports = exports['default'];