'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TextField = require('../Input/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TimePicker = function (_Component) {
  _inherits(TimePicker, _Component);

  /**
   * Class constructor takes properties and passes them to the parent/super
   */
  function TimePicker(props) {
    _classCallCheck(this, TimePicker);

    var _this = _possibleConstructorReturn(this, (TimePicker.__proto__ || Object.getPrototypeOf(TimePicker)).call(this, props));

    _this._handleInputChange = function (e) {
      var timeString = e.target.value;
      if (_this.props.onChange) {
        _this.props.onChange(timeString, e);
      }
    };

    _this._handleInputFocus = function (e) {
      e.target.blur();
      if (_this.props.onFocus) {
        _this.props.onFocus(e);
      }
    };

    _this.state = {
      date: _this.props.defaultDate,
      dialogDate: new Date()
    };
    return _this;
  }
  /**
   * Property types we handle
   */


  _createClass(TimePicker, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(_TextField2.default, {
        onChange: this._handleInputChange,
        type: 'time',
        value: this.props.value,
        onFocus: this._handleInputFocus
      });
    }

    /**
     * Handle native date input change
     */


    /**
     * Handle letting parent know we received focus
     */

  }]);

  return TimePicker;
}(_react.Component);

TimePicker.propTypes = {
  /**
   * Callback invoked when the user focuses on the time input
   */
  onFocus: _propTypes2.default.func,

  /**
   * Called when the value changes and passes timeAsString, event as params
   */
  onChange: _propTypes2.default.func,

  /**
   * Current value in '24hh:mm'
   */
  value: _propTypes2.default.string
};
exports.default = TimePicker;
module.exports = exports['default'];