'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var styles = exports.styles = function styles(theme) {
  return {
    radioButton: {
      marginRight: '15px'
    },

    radioButtonInput: {
      marginRight: '15px'
    },

    selectField: {
      display: 'inline-block',
      height: theme.picker.selectFieldHeight + 'px',
      fontSize: '16px',
      whiteSpace: 'nowrap',
      position: 'relative'
    },

    selectFieldControl: {
      cursor: 'pointer',
      clear: 'both',
      height: '100%',

      chamelMenuControlBg: {
        backgroundColor: theme.picker.menuBackgroundColor,
        height: '100%',
        width: '100%',
        opacity: 0
      },

      '&:hover': {
        opacity: 1
      },
      '&:focus': {
        opacity: 1
      }
    },

    selectFieldLabel: {
      lineHeight: '30px',
      paddingLeft: 0,
      marginRight: theme.picker.iconSize
    },

    selectFieldIcon: {
      position: 'absolute',
      top: theme.picker.selectFieldIconTop,
      right: 0,
      fill: theme.picker.iconColor,
      height: theme.picker.iconSize,
      width: theme.picker.iconSize
    },

    selectFieldUnderline: {
      height: '1px',
      backgroundColor: theme.picker.borderColor
    },

    selectFieldMenu: {
      maxHeight: '320px',
      overflow: 'auto'
    },

    selectButtonCon: {
      display: 'inline-block',
      position: 'relative',
      zIndex: 9
    },

    primary: {
      color: theme.picker.colorSchemes.primary.textColor,
      backgroundColor: theme.picker.colorSchemes.primary.backgroundColor
    },

    dark: {
      color: theme.picker.colorSchemes.dark.textColor,
      backgroundColor: theme.picker.colorSchemes.dark.backgroundColor
    },

    light: {
      color: theme.picker.colorSchemes.light.textColor,
      backgroundColor: theme.picker.colorSchemes.light.backgroundColor
    }
  };
};