'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _prefixer = require('../utils/prefixer.js');

var _prefixer2 = _interopRequireDefault(_prefixer);

var _classnames6 = require('classnames');

var _classnames7 = _interopRequireDefault(_classnames6);

var _injectStyles = require('../styles/injectStyles');

var _injectStyles2 = _interopRequireDefault(_injectStyles);

var _styles = require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Progress = function (_Component) {
  _inherits(Progress, _Component);

  /**
   * Class constructor
   *
   * @param {Object} props Properties to send to the render function
   */
  function Progress(props) {
    _classCallCheck(this, Progress);

    // Call paprent constructor
    return _possibleConstructorReturn(this, (Progress.__proto__ || Object.getPrototypeOf(Progress)).call(this, props));
  }

  _createClass(Progress, [{
    key: 'calculateRatio',
    value: function calculateRatio(value) {
      if (value < this.props.min) return 0;
      if (value > this.props.max) return 1;
      return (value - this.props.min) / (this.props.max - this.props.min);
    }
  }, {
    key: 'circularStyle',
    value: function circularStyle() {
      if (this.props.mode !== 'indeterminate') {
        return {
          strokeDasharray: 2 * Math.PI * 25 * this.calculateRatio(this.props.value) + ', 400'
        };
      }
    }
  }, {
    key: 'linearStyle',
    value: function linearStyle() {
      if (this.props.mode !== 'indeterminate') {
        return {
          buffer: (0, _prefixer2.default)({ transform: 'scaleX(' + this.calculateRatio(this.props.buffer) + ')' }),
          value: (0, _prefixer2.default)({ transform: 'scaleX(' + this.calculateRatio(this.props.value) + ')' })
        };
      } else {
        return {};
      }
    }
  }, {
    key: 'renderCircular',
    value: function renderCircular() {
      var _props = this.props,
          classes = _props.classes,
          mode = _props.mode,
          multicolor = _props.multicolor;


      var circleClassNames = (0, _classnames7.default)(classes.circle, _defineProperty({}, classes[mode + 'Circle'], mode));

      var pathClassNames = (0, _classnames7.default)(classes.path, _defineProperty({}, classes[mode + 'Path'], mode), _defineProperty({}, classes[mode + 'MulticolorPath'], multicolor));

      return _react2.default.createElement(
        'svg',
        { className: circleClassNames, viewBox: '0 0 60 60' },
        _react2.default.createElement('circle', { className: pathClassNames, style: this.circularStyle(), cx: '30', cy: '30', r: '25' })
      );
    }
  }, {
    key: 'renderLinear',
    value: function renderLinear() {
      var _linearStyle = this.linearStyle(),
          buffer = _linearStyle.buffer,
          value = _linearStyle.value;

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement('span', { 'data-ref': 'buffer', className: this.props.classes.buffer, style: buffer }),
        _react2.default.createElement('span', { 'data-ref': 'value', className: this.getClassNamesForLinearValue(), style: value })
      );
    }

    /**
     * Function that will create class names for linear value
     */

  }, {
    key: 'getClassNamesForLinearValue',
    value: function getClassNamesForLinearValue() {
      var _props2 = this.props,
          classes = _props2.classes,
          mode = _props2.mode;


      return (0, _classnames7.default)(classes.value, _defineProperty({}, classes[mode + 'Value'], mode));
    }
  }, {
    key: 'render',
    value: function render() {
      var _props3 = this.props,
          className = _props3.className,
          classes = _props3.classes,
          disabled = _props3.disabled,
          max = _props3.max,
          min = _props3.min,
          mode = _props3.mode,
          type = _props3.type,
          value = _props3.value,
          size = _props3.size;


      var _className = (0, _classnames7.default)(classes[type], _defineProperty({}, classes[mode], mode), classes[type + size + 'Size']);

      return _react2.default.createElement(
        'div',
        {
          disabled: disabled,
          'data-react-toolbox': 'progress-bar',
          'aria-valuenow': value,
          'aria-valuemin': min,
          'aria-valuemax': max,
          className: _className
        },
        type === 'circular' ? this.renderCircular() : this.renderLinear()
      );
    }
  }]);

  return Progress;
}(_react.Component);

// Wrap in JSS for styles


Progress.propTypes = {
  buffer: _propTypes2.default.number,
  className: _propTypes2.default.string,
  disabled: _propTypes2.default.bool,
  max: _propTypes2.default.number,
  min: _propTypes2.default.number,
  mode: _propTypes2.default.oneOf(['determinate', 'indeterminate']),
  multicolor: _propTypes2.default.bool,
  type: _propTypes2.default.oneOf(['linear', 'circular']),
  value: _propTypes2.default.number,
  size: _propTypes2.default.oneOf(['small', 'normal'])
};
Progress.defaultProps = {
  buffer: 0,
  className: '',
  max: 100,
  min: 0,
  mode: 'indeterminate',
  multicolor: false,
  type: 'circular',
  value: 0,
  size: 'normal'
};
exports.default = (0, _injectStyles2.default)(_styles.styles, Progress);
module.exports = exports['default'];