'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var styles = exports.styles = function styles(theme) {
  return {

    linear: {
      position: 'relative',
      display: 'inline-block',
      overflow: 'hidden',
      background: theme.progress.backgroundColor
    },

    linearnormalSize: {
      width: '100%',
      height: '4px'
    },

    indeterminateValue: {
      'transform-origin': 'center center !important',
      animation: 'linearIndeterminateBar 1s linear infinite'
    },

    bufferValue: {
      position: 'absolute',
      top: 0,
      right: 0,
      bottom: 0,
      left: 0,
      'transition-timing-function': theme.progress.curveDefault,
      'transition-duration': theme.progress.animationDuration + 's',
      transform: 'scaleX(0)',
      'transform-origin': 'left center'
    },

    buffer: {
      extend: 'bufferValue',
      'background-image': theme.progress.backgroundImage
    },

    value: {
      extend: 'bufferValue',
      'background-color': theme.progress.mainColor
    },

    'value [disabled]': {
      'background-color': theme.progress.disabledColor
    },

    'buffer [disabled]': {
      'background-image': theme.progress.disabledBackgroundImage
    },

    circular: {
      position: 'relative',
      display: 'inline-block',
      width: '60px',
      height: '60px',
      transform: 'rotate(-90deg)'
    },

    circularnormalSize: {
      width: '60px',
      height: '60px'
    },

    circularsmallSize: {
      width: '30px',
      height: '30px'
    },

    indeterminateCircle: {
      animation: 'circularIndeterminateBarRotate 2s linear infinite'
    },

    indeterminatePath: {
      animation: 'circularIndeterminateBarDash 1.5s ease-in-out infinite',
      'stroke-dasharray': '1.25, 250',
      'stroke-dashoffset': 0
    },

    indeterminateMulticolorPath: {
      animation: 'circularIndeterminateBarDash 1.5s ease-in-out infinite, circularIndeterminateColors 6s ease-in-out infinite'
    },

    circle: {
      width: '100%',
      height: '100%'
    },

    path: {
      transition: 'stroke-dasharray ' + theme.progress.animationDuration + 's ' + theme.progress.curveDefault,
      fill: 'none',

      'stroke-dasharray': '0, 250',
      'stroke-dashoffset': 0,
      'stroke-linecap': 'round',
      'stroke-miterlimit': 20,
      'stroke-width': 4,
      'stroke': theme.progress.mainColor
    },

    '@keyframes linearIndeterminateBar': {
      '0%': {
        transform: 'translate(-50%) scaleX(0)'
      },

      '50%': {
        transform: 'translate(0%) scaleX(0.3)'
      },

      '100%': {
        transform: 'translate(50%) scaleX(0)'
      }
    },

    '@keyframes circularIndeterminateBarRotate': {
      '100%': {
        transform: 'rotate(360deg)'
      }
    },

    '@keyframes circularIndeterminateBarDash': {
      '0%': {
        'stroke-dasharray': '1.25, 250',
        'stroke-dashoffset': '0'
      },

      '50%': {
        'stroke-dasharray': '111.25, 250',
        'stroke-dashoffset': '-43.75'
      },

      '100%': {
        'stroke-dasharray': '111.25, 250',
        'stroke-dashoffset': '-155'
      }
    },

    '@keyframes circularIndeterminateColors': {
      '0%': {
        stroke: '#4285f4'
      },

      '25%': {
        stroke: '#de3e35'
      },

      '50%': {
        stroke: '#f7c223'
      },

      '75%': {
        stroke: '#1b9a59'
      },

      '100%': {
        stroke: '#4285f4'
      }
    }
  };
};