'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _FlatButton = require('../Button/FlatButton');

var _FlatButton2 = _interopRequireDefault(_FlatButton);

var _styles = require('./styles');

var _injectStyles = require('../styles/injectStyles');

var _injectStyles2 = _interopRequireDefault(_injectStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Create a snackbar notice
 */
var Snackbar = function (_Component) {
  _inherits(Snackbar, _Component);

  /**
   * Class constructor
   *
   * @param {Object} props Properties to send to the render function
   */
  function Snackbar(props) {
    _classCallCheck(this, Snackbar);

    var _this = _possibleConstructorReturn(this, (Snackbar.__proto__ || Object.getPrototypeOf(Snackbar)).call(this, props));
    // Call parent constructor


    _this.state = {
      open: _this.props.open || false
    };
    return _this;
  }

  _createClass(Snackbar, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      var _this2 = this;

      if (prevState.open != this.state.open && this.props.timeout) {
        if (this.timer) {
          clearTimeout(this.timer);
        }

        this.timer = setTimeout(function () {
          _this2.dismiss();
        }, this.props.timeout);
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this3 = this;

      if (this.props.open) {
        if (this.timer) {
          clearTimeout(this.timer);
        }
        this.timer = setTimeout(function () {
          _this3.dismiss();
        }, this.props.timeout);
      }
    }

    /**
     * Handle incoming new props
     */

  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState({ open: nextProps.open || false });
    }
  }, {
    key: 'render',
    value: function render() {
      var propsClasses = this.props.classes;
      var classes = (0, _classnames3.default)(propsClasses.snackbar, _defineProperty({}, propsClasses.snackbarIsOpen, this.state.open));
      var action = void 0;

      if (this.props.action) {
        action = _react2.default.createElement(_FlatButton2.default, {
          className: propsClasses.snackbarAction,
          label: this.props.action,
          onClick: this.props.onActionClick
        });
      }

      return _react2.default.createElement(
        'span',
        { className: classes },
        _react2.default.createElement(
          'span',
          { className: propsClasses.snackbarMessage },
          this.props.message
        ),
        action
      );
    }
  }, {
    key: 'dismiss',
    value: function dismiss() {
      if (this.state.open) {
        this.setState({ open: false });
      }

      if (this.props.onDismiss) {
        this.props.onDismiss();
      }
    }
  }]);

  return Snackbar;
}(_react.Component);

// Wrap in JSS for styles


Snackbar.propTypes = {
  action: _propTypes2.default.string,
  message: _propTypes2.default.string.isRequired,
  open: _propTypes2.default.bool,
  onActionClick: _propTypes2.default.func,
  timeout: _propTypes2.default.number,
  onDismiss: _propTypes2.default.func
};
exports.default = (0, _injectStyles2.default)(_styles.styles, Snackbar);
module.exports = exports['default'];