'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('./styles');

var _injectStyles = require('../styles/injectStyles');

var _injectStyles2 = _interopRequireDefault(_injectStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Get SVG icon
 *
 * @param {Object} props
 * @returns {JSX}
 */
var SvgIcon = function SvgIcon(props) {
  // Always use the default icon class and add optional extension class if passed
  var classNames = props.classes.icon;
  if (props.iconClass && props.classes[props.iconClass]) {
    classNames += ' ' + props.classes[props.iconClass];
  }

  var IconComponent = props.iconElement;
  return _react2.default.createElement(IconComponent, { className: classNames });
};

/**
 * Accepted PropTypes
 */
SvgIcon.propTypes = {
  /**
   * JSS styles
   */
  classes: _propTypes2.default.object,

  /**
   * Optional class to apply from ./styles.js
   */
  iconClass: _propTypes2.default.string,

  /**
   * The icon component to render
   */
  iconElement: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.func]).isRequired
};

/**
 * Set defaults
 */
SvgIcon.defaultProps = {
  iconClass: null
};

// Wrap in JSS for styles
exports.default = (0, _injectStyles2.default)(_styles.styles, SvgIcon);
module.exports = exports['default'];