'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('./styles');

var _injectStyles = require('../styles/injectStyles');

var _injectStyles2 = _interopRequireDefault(_injectStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Table = function Table(props) {
  var classes = props.classes.table;
  if (props.fixedWidth) {
    classes += ' ' + props.classes.tableFixedWidth;
  }

  return _react2.default.createElement(
    'table',
    { className: classes },
    props.children
  );
};

Table.defaultProps = {
  fixedWidth: true
};

Table.propTypes = {
  /**
   * Contents of the cell
   */
  children: _propTypes2.default.any,

  /**
   * If true the table layout will be fixed-width
   */
  fixedWidth: _propTypes2.default.bool,

  /**
   * JSS classes for styling the component
   */
  classes: _propTypes2.default.object
};

exports.default = (0, _injectStyles2.default)(_styles.styles, Table);
module.exports = exports['default'];