'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('./styles');

var _injectStyles = require('../styles/injectStyles');

var _injectStyles2 = _interopRequireDefault(_injectStyles);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _Checkbox = require('../Toggle/Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Row = function (_React$Component) {
  _inherits(Row, _React$Component);

  /**
   * Class constructor
   *
   * @param {Object} props Properties to send to the render function
   */

  /**
   * Set some sane defaults
   */
  function Row(props) {
    _classCallCheck(this, Row);

    var _this = _possibleConstructorReturn(this, (Row.__proto__ || Object.getPrototypeOf(Row)).call(this, props));

    _this.state = {
      mouseIsHoveredOver: false
    };
    return _this;
  }

  _createClass(Row, [{
    key: 'render',
    value: function render() {
      var _classnames,
          _this2 = this;

      var classNames = (0, _classnames3.default)(this.props.classes.row, (_classnames = {}, _defineProperty(_classnames, this.props.classes.rowEmphasized, this.props.emphasized), _defineProperty(_classnames, this.props.classes.rowSelected, this.props.selected), _defineProperty(_classnames, this.props.classes.rowTappable, this.props.onTap), _classnames));

      // Find out if we should display a checkbox column
      var checkBoxColumn = null;
      if (this.props.showCheckBox) {
        var showElement = _react2.default.createElement(_Checkbox2.default, { checked: this.props.selected });

        // If iconElement is not null and item is not selected, then use icon
        if (this.props.iconElement && !this.props.selected && !this.state.mouseIsHoveredOver) {
          showElement = this.props.iconElement;
        }
        checkBoxColumn = _react2.default.createElement(
          'td',
          {
            className: this.props.classes.cell + ' ' + this.props.classes.iconCell,
            onClick: function onClick(event) {
              event.preventDefault(); // Let's stop this event.
              event.stopPropagation(); // Really this time.
              _this2.props.onLeftElementTap();
            }
          },
          showElement
        );
      }

      return _react2.default.createElement(
        'tr',
        {
          onClick: this.props.onTap,
          className: classNames,
          onMouseEnter: function onMouseEnter() {
            _this2.setState({ mouseIsHoveredOver: true });
          },
          onMouseLeave: function onMouseLeave() {
            _this2.setState({ mouseIsHoveredOver: false });
          }
        },
        checkBoxColumn,
        this.props.children
      );
    }
  }]);

  return Row;
}(_react2.default.Component);

Row.defaultProps = {
  showCheckBox: true,
  onLeftElementTap: null
};
Row.propTypes = {
  /**
   * Contents of the cell
   */
  children: _propTypes2.default.any,

  /**
   * JSS classes for styling the component
   */
  classes: _propTypes2.default.object,

  /**
   * Optional flag that can be set to indicate this item is selected
   */
  selected: _propTypes2.default.bool,

  /**
   * Used to highlight an entry - often used to mark a new entry
   */
  emphasized: _propTypes2.default.bool,

  /**
   * Event called when the primary action is tapped or Clicked
   */
  onTap: _propTypes2.default.func,

  /**
   * If set, then unselected rows will display the icon element
   */
  iconElement: _propTypes2.default.node,

  /**
   * If true then each row adds a column for a checkbox
   */
  showCheckBox: _propTypes2.default.bool,

  /**
   * Callback called any time the user taps the checkbox or icon
   */
  onLeftElementTap: _propTypes2.default.func
};
exports.default = (0, _injectStyles2.default)(_styles.styles, Row);
module.exports = exports['default'];