'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styles = require('./styles');

var _injectStyles = require('../styles/injectStyles');

var _injectStyles2 = _interopRequireDefault(_injectStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RowCell = function RowCell(props) {
  return _react2.default.createElement(
    'td',
    { title: props.title, className: props.classes.cell, style: props.style },
    props.children
  );
};

RowCell.propTypes = {
  /**
   * Contents of the cell
   */
  children: _propTypes2.default.any,

  /**
   * JSS classes for styling the component
   */
  classes: _propTypes2.default.object,

  /**
   * Optional width of the column
   */
  width: _propTypes2.default.string,

  /**
   * Optional style overrides - often used to set width
   */
  style: _propTypes2.default.object,

  /**
   * Title used to tell the user somethign when they hover over a cell
   */
  title: _propTypes2.default.string
};

exports.default = (0, _injectStyles2.default)(_styles.styles, RowCell);
module.exports = exports['default'];