'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BodyTextUnstyled = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _textStyles = require('./textStyles');

var _injectStyles = require('../styles/injectStyles');

var _injectStyles2 = _interopRequireDefault(_injectStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Main body text
 *
 * @param {Object} props
 * @returns {Object}
 */
var BodyText = function BodyText(props) {
  return _react2.default.createElement(
    'p',
    { style: props.style, className: props.classes.body },
    props.children
  );
};

/**
 * Accepted PropTypes
 */
BodyText.propTypes = {
  /**
   * JSS styles
   */
  classes: _propTypes2.default.object,

  /**
   * Contents of the header
   */
  children: _propTypes2.default.any,

  /**
   * Optional style overrides
   */
  style: _propTypes2.default.object
};

// Export an unstyled version for unit tests
var BodyTextUnstyled = exports.BodyTextUnstyled = BodyText;

// Wrap in JSS for styles
exports.default = (0, _injectStyles2.default)(_textStyles.styles, BodyText);