'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _textStyles = require('./textStyles');

var _injectStyles = require('../styles/injectStyles');

var _injectStyles2 = _interopRequireDefault(_injectStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Large alternate display header
 *
 * @param {Object} props
 * @returns {Object}
 */
var DisplayHeader = function DisplayHeader(props) {
  return _react2.default.createElement(
    'h1',
    { className: props.classes['display' + props.level] },
    props.children
  );
};

/**
 * Accepted PropTypes
 */
DisplayHeader.propTypes = {
  /**
   * JSS styles
   */
  classes: _propTypes2.default.object,

  /**
   * Contents of the header
   */
  children: _propTypes2.default.any,

  /**
   * Levels 1-4 are supported
   */
  level: _propTypes2.default.oneOf([1, 2, 3, 4])
};

/**
 * Set sane defaults where needed
 */
DisplayHeader.defaultPropts = {
  level: 1
};

// Wrap in JSS for styles
exports.default = (0, _injectStyles2.default)(_textStyles.styles, DisplayHeader);
module.exports = exports['default'];