'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HeadingUnstyled = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _textStyles = require('./textStyles');

var _injectStyles = require('../styles/injectStyles');

var _injectStyles2 = _interopRequireDefault(_injectStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Text header compontn
 *
 * @param {Object} props
 * @returns {Object}
 */
var Heading = function Heading(props) {
  switch (props.level) {
    case 1:
      {
        return _react2.default.createElement(
          'h1',
          { style: props.style, className: props.classes.heading1 },
          props.children
        );
      }
    case 2:
      {
        return _react2.default.createElement(
          'h2',
          { style: props.style, className: props.classes.heading2 },
          props.children
        );
      }
    case 3:
      {
        return _react2.default.createElement(
          'h3',
          { style: props.style, className: props.classes.heading3 },
          props.children
        );
      }
    case 4:
    case 5:
    case 6:
      {
        return _react2.default.createElement(
          'h4',
          { style: props.style, className: props.classes.heading4 },
          props.children
        );
      }
  }
};

/**
 * Accepted PropTypes
 */
Heading.propTypes = {
  /**
   * JSS styles
   */
  classes: _propTypes2.default.object,

  /**
   * Contents of the header
   */
  children: _propTypes2.default.any,

  /**
   * Levels 1-4 are supported, but 5-6 are for h5-h6 HTML compat
   */
  level: _propTypes2.default.oneOf([1, 2, 3, 4, 5, 6]),

  /**
   * Optional style overrides
   */
  style: _propTypes2.default.object
};

/**
 * Set sane defaults where needed
 */
Heading.defaultPropts = {
  level: 1
};

// Export an unstyled version for unit tests
var HeadingUnstyled = exports.HeadingUnstyled = Heading;

// Wrap in JSS for styles
exports.default = (0, _injectStyles2.default)(_textStyles.styles, Heading);