'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _textStyles = require('./textStyles');

var _injectStyles = require('../styles/injectStyles');

var _injectStyles2 = _interopRequireDefault(_injectStyles);

var _reactMarkdown = require('react-markdown');

var _reactMarkdown2 = _interopRequireDefault(_reactMarkdown);

var _HeadingText = require('./HeadingText');

var _HeadingText2 = _interopRequireDefault(_HeadingText);

var _BodyText = require('./BodyText');

var _BodyText2 = _interopRequireDefault(_BodyText);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Map renderers to chameleon components where possible
 * See: https://github.com/rexxars/react-markdown/blob/master/src/renderers.js
 */
var renderComponts = {
  heading: _HeadingText2.default,
  p: _BodyText2.default
};

/**
 * Render an HTML string
 *
 * @param {Object} props
 * @returns {Object}
 */
var HtmlText = function HtmlText(props) {
  return _react2.default.createElement(_reactMarkdown2.default, { source: props.source, renderers: renderComponts });
};

/**
 * Accepted PropTypes
 */
HtmlText.propTypes = {
  /**
   * JSS styles
   */
  classes: _propTypes2.default.object,

  /**
   * Raw string to render
   */
  source: _propTypes2.default.string
};

// Wrap in JSS for styles
exports.default = (0, _injectStyles2.default)(_textStyles.styles, HtmlText);
module.exports = exports['default'];