'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactTestRenderer = require('react-test-renderer');

var _reactTestRenderer2 = _interopRequireDefault(_reactTestRenderer);

var _HtmlText = require('../HtmlText');

var _HtmlText2 = _interopRequireDefault(_HtmlText);

var _HeadingText = require('../HeadingText');

var _HeadingText2 = _interopRequireDefault(_HeadingText);

var _BodyText = require('../BodyText');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('Text/HtmlText', function () {
  it('Should render', function () {
    var renderer = _reactTestRenderer2.default.create(_react2.default.createElement(_HtmlText2.default, { html: '<h1>Heading</h1>' }));
    expect(renderer.root.findByType(_HtmlText2.default)).not.toBeNull();
  });
  it('Should transform h1 to Text/Heading', function () {
    var renderer = _reactTestRenderer2.default.create(_react2.default.createElement(_HtmlText2.default, { html: '<h1>Heading</h1>' }));
    expect(renderer.root.findByType(_HeadingText.HeadingUnstyled)).not.toBeNull();
  });
  it('Should transform h2 to Text/Heading', function () {
    var renderer = _reactTestRenderer2.default.create(_react2.default.createElement(_HtmlText2.default, { html: '<h2>Heading</h2>' }));
    expect(renderer.root.findByType(_HeadingText.HeadingUnstyled)).not.toBeNull();
  });
  it('Should transform h3 to Text/Heading', function () {
    var renderer = _reactTestRenderer2.default.create(_react2.default.createElement(_HtmlText2.default, { html: '<h3>Heading</h3>' }));
    expect(renderer.root.findByType(_HeadingText.HeadingUnstyled)).not.toBeNull();
  });
  it('Should transform h4 to Text/Heading', function () {
    var renderer = _reactTestRenderer2.default.create(_react2.default.createElement(_HtmlText2.default, { html: '<h4>Heading</h4>' }));
    expect(renderer.root.findByType(_HeadingText.HeadingUnstyled)).not.toBeNull();
  });
  it('Should transform <p> to Text/Body', function () {
    var renderer = _reactTestRenderer2.default.create(_react2.default.createElement(_HtmlText2.default, { html: '<p>body</p>' }));
    expect(renderer.root.findByType(_BodyText.BodyTextUnstyled)).not.toBeNull();
  });
  it('Should prefer custom transform', function () {
    var renderer = _reactTestRenderer2.default.create(_react2.default.createElement(_HtmlText2.default, {
      html: '<p>body</p>',
      transform: function transform(domNode) {
        return _react2.default.createElement(
          'span',
          null,
          'replaced'
        );
      }
    }));
    expect(renderer.root.findByType('span')).not.toBeNull();
  });
});