'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = exports.styles = function styles(theme) {
  var _fixedBelowAppbar;

  return {
    toolbar: {
      'background-color': theme.toolbar.backgroundColor,
      height: '56px',
      width: '100%',
      padding: 0,
      'box-sizing': 'border-box',
      display: 'flex',
      '-webkit-flex-direction': 'row' /* Safari */
      , 'flex-direction': 'row',
      '-webkit-flex-wrap': 'wrap' /* Safari */
      , 'flex-wrap': 'wrap',
      '-webkit-align-items': 'center' /* Safari */
      , 'align-items': 'center'
    },

    chamelToolbarLeftArrow: {
      'text-align': 'left',
      cursor: 'pointer',
      width: '45px'
    },

    chamelToolbarRightArrow: {
      'text-align': 'right',
      flex: '1 1 auto',
      cursor: 'pointer',
      width: '35px',
      'margin-right': '5px'
    },

    /**
     * Secondary toolbars are used for inline elements like
     * an editor and do not need to be so prominent as primary
     */
    toolbarSecondary: {
      'background-color': 'transparent',
      height: 'auto'
    },

    toolbarGroupSeparator: {
      'flex-basis': 'content',
      width: '1px',
      'background-color': '#cccccc'
    },

    toolbarGroupRight: {
      'text-align': 'right',
      flex: '1 1 auto'
    },

    toolbarGroupLeft: {
      'text-align': 'left',
      'flex-basis': 'content'
    },

    fixedBelowAppbar: (_fixedBelowAppbar = {
      position: 'fixed',
      marginTop: theme.appBar.heightSmall
    }, _defineProperty(_fixedBelowAppbar, '@media screen and (min-width: ' + theme.breakpoints.medium + 'px)}', {
      marginTop: theme.appBar.heightMedium
    }), _defineProperty(_fixedBelowAppbar, '@media screen and (min-width: ' + theme.breakpoints.large + 'px)}', {
      marginTop: theme.appBar.heightLarge
    }), _fixedBelowAppbar)
  };
};