'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _FontIcon = require('../../FontIcon');

var _FontIcon2 = _interopRequireDefault(_FontIcon);

var _styles = require('./styles');

var _injectStyles = require('../../styles/injectStyles');

var _injectStyles2 = _interopRequireDefault(_injectStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Title Icon button
 *
 * @param props
 * @param context
 * @returns {ReactDOM}
 * @constructor
 */
var TitleIcon = function TitleIcon(props, context) {
  var fontIconProps = _extends({}, props);

  var headerType = null;
  if (props.headerType) {
    headerType = props.headerType;
    delete fontIconProps.headerType;
  }

  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(
      _FontIcon2.default,
      _extends({}, fontIconProps, { className: props.classes.iconTitle }),
      'title'
    ),
    _react2.default.createElement(
      'span',
      { className: props.classes.iconTitleType },
      headerType
    )
  );
};

// Wrap in JSS for styles
exports.default = (0, _injectStyles2.default)(_styles.styles, TitleIcon);
module.exports = exports['default'];