'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var styles = exports.styles = function styles(theme) {
  return {
    '@font-face': _defineProperty({
      fontFamily: "'Material Icons'",
      fontStyle: 'normal',
      fontWeight: 400,
      /* For IE6-8 */
      src: 'url("../fonts/MaterialIcons-Regular.eot")'
    }, 'src', 'local("Material Icons"), local("MaterialIcons-Regular"),' + 'url("../fonts/MaterialIcons-Regular.woff2") format("woff2"),' + 'url("../fonts/MaterialIcons-Regular.woff") format("woff"),' + 'url("../fonts/MaterialIcons-Regular.ttf") format("truetype")'),

    'material-icons': {
      fontFamily: 'Material Icons',
      fontWeight: 'normal',
      fontStyle: 'normal',
      fontSize: '24px' /* Preferred icon size */
      , display: 'inline-block',
      lineHeight: 1,
      textTransform: 'none',
      letterSpacing: 'normal',
      wordWrap: 'normal',
      whiteSpace: 'nowrap',
      direction: 'ltr',
      verticalAlign: 'middle',

      /* Support for all WebKit browsers. */
      '-webkit-font-smoothing': 'antialiased',
      /* Support for Safari and Chrome. */
      'text-rendering': 'optimizeLegibility',

      /* Support for Firefox. */
      '-moz-osx-font-smoothing': 'grayscale',

      /* Support for IE. */
      'font-feature-settings': 'liga',

      '&md-18': {
        fontSize: '18px !important'
      },

      '&md-24': {
        fontSize: '24px !important'
      },

      '&md-36': {
        fontSize: '36px !important'
      },

      '&md-48': {
        fontSize: '48px !important'
      },

      /* Rules for using icons as black on a light background. */
      '&md-dark': {
        color: theme.font.colorScheme.dark,
        '&md-inactive': {
          color: theme.font.colorScheme.darkInactive
        }
      },

      /* Rules for using icons as white on a dark background. */
      '&md-light': {
        color: theme.font.colorScheme.light,
        '&md-inactive': {
          color: theme.font.colorScheme.lightInactive
        }
      }
    },

    /**
     * Navigation Icons
     */
    iconAccessibility: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconAccessTime: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconAccount: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconAdd: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconAddCircle: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconAnnouncement: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconApps: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconArrowBack: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconArrowDown: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconArrowDropDown: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconArrowDropDownCircle: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconArrowDropUp: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconArrowForward: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconArrowRight: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconArrowUp: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconAttachment: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconAttachFile: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconBorderColor: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconBuild: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconCancel: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconCheck: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconCheckCircle: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconChevronLeft: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconChevronRight: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconClose: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconCode: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconComment: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconContacts: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconContentPaste: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconDashboard: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconDateRange: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconDelete: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconEdit: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconEmail: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconExpandLess: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconExpandMore: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconFilterList: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconFindPage: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconFirstPage: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconFlag: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconFullScreen: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconFullScreenExit: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconGroup: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconInbox: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconLabel: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconLastPage: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconLibraryBooks: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconLocalOffer: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconMenu: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconMerge: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconMoreHoriz: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconMoreVert: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconNote: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconPersonAdd: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconPhoto: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconPhotoCamera: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconPrint: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconRefresh: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconSave: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconSearch: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconSend: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconSettings: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconSettingsApplication: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconShuffle: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconStreetView: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconStyle: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconSubArrowLeft: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconSubArrowRight: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconSwapHoriz: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconTransform: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconViewList: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconWeb: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconWork: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    /**
     * Editor Icons
     */

    iconBold: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconUnderlined: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconItalic: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconLink: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconListNumbered: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconListBulleted: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconTitle: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons'),

    iconTitleType: {
      position: 'absolute',
      top: '20px',
      left: '35px'
    },

    /*
     * Something else
     */
    iconCreate: _defineProperty({
      extend: 'fontIcon'
    }, 'extend', 'material-icons')
  };
};