'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _themeAutoSelector = require('../themeAutoSelector');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('styles/themeAutoselector', function () {
  it('getTheme should return a theme for android', function () {
    var uaMock = {
      getOS: function getOS() {
        return { name: 'Android' };
      },
      getBrowser: function getBrowser() {
        return { name: 'Chrome' };
      }
    };
    expect((0, _themeAutoSelector.getTheme)(uaMock)).not.toBeNull();
  });

  it('getTheme should return a theme for windows', function () {
    var uaMock = {
      getOS: function getOS() {
        return { name: 'Windows' };
      },
      getBrowser: function getBrowser() {
        return { name: 'Chrome' };
      }
    };
    expect((0, _themeAutoSelector.getTheme)(uaMock)).not.toBeNull();
  });

  it('getTheme should return a theme for ios', function () {
    var uaMock = {
      getOS: function getOS() {
        return { name: 'ios' };
      },
      getBrowser: function getBrowser() {
        return { name: 'Chrome' };
      }
    };
    expect((0, _themeAutoSelector.getTheme)(uaMock)).not.toBeNull();
  });
});