'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _simpleAssign = require('simple-assign');

var _simpleAssign2 = _interopRequireDefault(_simpleAssign);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ChamelThemeProvider = require('./ChamelThemeProvider');

var _ChamelThemeProvider2 = _interopRequireDefault(_ChamelThemeProvider);

var _themes = require('./themes');

var _themes2 = _interopRequireDefault(_themes);

var _reactJss = require('react-jss');

var _reactJss2 = _interopRequireDefault(_reactJss);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

exports.default = function (stylesOrCreator, InnerComponent) {
  var _class, _temp;

  var StyledInnerComponent = (0, _reactJss2.default)(stylesOrCreator)(InnerComponent);

  return _temp = _class = function (_Component) {
    _inherits(ChamelStyleHOC, _Component);

    /**
     * Make sure we call the parent constructor
     *
     * @param {Object} props
     * @param {Object} context
     */

    /**
     * Keep a reference to an InnerComponent for testing purposes
     */
    function ChamelStyleHOC(props, context) {
      _classCallCheck(this, ChamelStyleHOC);

      return _possibleConstructorReturn(this, (ChamelStyleHOC.__proto__ || Object.getPrototypeOf(ChamelStyleHOC)).call(this, props, context));
    }

    /**
     * Wrap the inner component
     */


    /**
     * Check if the theme was already passed down
     */


    _createClass(ChamelStyleHOC, [{
      key: 'render',
      value: function render() {
        // Pass all props down to the sytled inner component
        var props = {};
        (0, _simpleAssign2.default)(props, this.props);

        // Check to see if theme is in context and wrap if not
        if (!this.context['__THEMING__']) {
          return _react2.default.createElement(
            _ChamelThemeProvider2.default,
            { theme: _themes2.default },
            _react2.default.createElement(StyledInnerComponent, props)
          );
        } else {
          return _react2.default.createElement(StyledInnerComponent, props);
        }
      }
    }]);

    return ChamelStyleHOC;
  }(_react.Component), _class.InnerComponent = InnerComponent, _class.contextTypes = _defineProperty({}, '__THEMING__', _propTypes2.default.object), _temp;
};

module.exports = exports['default'];