'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _colors = require('./colors');

var _colors2 = _interopRequireDefault(_colors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Theme matching google material design for android and web
 *
 * These variables will override the theme variables found in base
 * so it is only necessary to set properties that need to be different
 * than the base theme.
 */
var material = {
  themeName: 'material',
  body: {
    backgroundColor: '#f2f2f2'
  },
  paper: {
    backgroundColorDepth1: _colors2.default.fullWhite,
    boxShadowDepth1: '0 1px 4px rgba(0, 0, 0, 0.24)',
    boxShadowDepth1Bottom: '0 1px 6px rgba(0, 0, 0, 0.12)',
    backgroundColorDepth2: _colors2.default.fullWhite,
    boxShadowDepth2: '0 3px 10px rgba(0, 0, 0, 0.23)',
    boxShadowDepth2Bottom: '0 3px 10px rgba(0, 0, 0, 0.16)',
    backgroundColorDepth3: _colors2.default.fullWhite,
    boxShadowDepth3: '0 6px 10px rgba(0, 0, 0, 0.23)',
    boxShadowDepth3Bottom: '0 10px 30px rgba(0, 0, 0, 0.19)',
    backgroundColorDepth4: _colors2.default.fullWhite,
    boxShadowDepth4: '0 10px 18px rgba(0, 0, 0, 0.22)',
    boxShadowDepth4Bottom: '0 14px 45px rgba(0, 0, 0, 0.25)',
    backgroundColorDepth5: _colors2.default.fullWhite,
    boxShadowDepth5: '0 15px 20px rgba(0, 0, 0, 0.22)',
    boxShadowDepth5Bottom: '0 19px 60px rgba(0, 0, 0, 0.30)'
  }
};

exports.default = material;
module.exports = exports['default'];