'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.themeBuilder = undefined;

var _themeBase = require('./theme-base');

var _themeBase2 = _interopRequireDefault(_themeBase);

var _deepmerge = require('deepmerge');

var _deepmerge2 = _interopRequireDefault(_deepmerge);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Create a theme that can be used in chamel
 *
 * @param {*} props Properties overriding theme variables found in ./theme-base.js
 * @param {*} inheritFrom Optional theme to inherit from, defaults to base if not set
 */
var themeBuilder = exports.themeBuilder = function themeBuilder(props) {
  var inheritFrom = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _themeBase2.default;

  return (0, _deepmerge2.default)(inheritFrom, props);
};