'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.human = exports.modern = exports.material = undefined;

var _themeBuilder = require('./themeBuilder');

var _themeBase = require('./theme-base');

var _themeBase2 = _interopRequireDefault(_themeBase);

var _themeMaterial = require('./theme-material');

var _themeMaterial2 = _interopRequireDefault(_themeMaterial);

var _themeModern = require('./theme-modern');

var _themeModern2 = _interopRequireDefault(_themeModern);

var _themeHuman = require('./theme-human');

var _themeHuman2 = _interopRequireDefault(_themeHuman);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Merge with base and export the google material theme


/**
 * Import all themes
 */
var material = exports.material = (0, _themeBuilder.themeBuilder)(_themeMaterial2.default, _themeBase2.default);

// Merge with base and export microsoft modern
var modern = exports.modern = (0, _themeBuilder.themeBuilder)(_themeModern2.default, _themeBase2.default);

// Merge with base and export the apple human theme
var human = exports.human = (0, _themeBuilder.themeBuilder)(_themeHuman2.default, _themeBase2.default);

exports.default = material;