'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.onAnimationEnd = exports.onTransitionEnd = exports.animationEndEventName = exports.transitionEndEventName = undefined;

var _Events = require('./Events');

var _Events2 = _interopRequireDefault(_Events);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var testSupportedProps = function testSupportedProps(props) {
  var i,
      undefined,
      el = document.createElement('div');

  for (i in props) {
    if (props.hasOwnProperty(i) && el.style[i] !== undefined) {
      return props[i];
    }
  }
};

/* 
 * Returns the correct event name to use
 */
var transitionEndEventName = exports.transitionEndEventName = function transitionEndEventName() {
  return testSupportedProps({
    transition: 'transitionend',
    OTransition: 'otransitionend',
    MozTransition: 'transitionend',
    WebkitTransition: 'webkitTransitionEnd'
  });
};

var animationEndEventName = exports.animationEndEventName = function animationEndEventName() {
  return testSupportedProps({
    animation: 'animationend',
    '-o-animation': 'oAnimationEnd',
    '-moz-animation': 'animationend',
    '-webkit-animation': 'webkitAnimationEnd'
  });
};

var onTransitionEnd = exports.onTransitionEnd = function onTransitionEnd(el, callback) {
  var transitionEnd = undefined.transitionEndEventName();

  _Events2.default.once(el, transitionEnd, function () {
    return callback();
  });
};

var onAnimationEnd = exports.onAnimationEnd = function onAnimationEnd(el, callback) {
  var animationEnd = undefined.animationEndEventName();

  _Events2.default.once(el, animationEnd, function () {
    return callback();
  });
};

exports.default = {
  transitionEndEventName: transitionEndEventName,
  animationEndEventName: animationEndEventName,
  onTransitionEnd: onTransitionEnd,
  onAnimationEnd: onAnimationEnd
};