'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var once = exports.once = function once(el, type, callback) {
  var typeArray = type.split(' ');
  var recursiveFunction = function recursiveFunction(e) {
    e.target.removeEventListener(e.type, recursiveFunction);
    return callback(e);
  };

  for (var i = typeArray.length - 1; i >= 0; i--) {
    undefined.on(el, typeArray[i], recursiveFunction);
  }
};

// IE8+ Support
var on = exports.on = function on(el, type, callback) {
  if (el.addEventListener) {
    el.addEventListener(type, callback);
  } else {
    el.attachEvent('on' + type, function () {
      callback.call(el);
    });
  }
};

// IE8+ Support
var off = exports.off = function off(el, type, callback) {
  if (el.removeEventListener) {
    el.removeEventListener(type, callback);
  } else {
    el.detachEvent('on' + type, callback);
  }
};

exports.default = {
  once: once,
  on: on,
  off: off
};