import React from 'react';
import PropTypes from 'prop-types';
import SelectButton from '../Picker/SelectButton';

/**
 * Wrapper for an SelectButton in the AppBar
 *
 * @param props
 * @returns {ReactDOM}
 */
const AppBarSelectButton = props => {
  // Get className and children, and put the rest in other to forward below
  let { className, children, ...other } = props;

  // TODO: If we need to add a class to the button we can do it here

  return (
    <SelectButton className={className} {...other}>
      {children}
    </SelectButton>
  );
};

/**
 * Set accepted properties
 */
AppBarSelectButton.propTypes = {
  /**
   * Optional class override
   */
  className: PropTypes.string,

  /**
   * Child elements (text and icon)
   */
  children: PropTypes.node,
};

/**
 * Set property defaults
 */
AppBarSelectButton.defaultProps = {
  className: '',
  children: null,
};

export default AppBarSelectButton;

