export const styles = theme => ({
  outerContainer: {
    height: theme.appBar.heightSmall,
    ['@media screen and (min-width: ' + theme.breakpoints.medium + 'px)}']: {
      height: theme.appBar.heightMedium,
    },
    ['@media screen and (min-width: ' + theme.breakpoints.large + 'px)}']: {
      height: theme.appBar.heightLarge,
    },
  },
  appBar: {
    width: '100%',
    boxSizing: 'border-box',
    display: 'flex',
    flexDirection: 'row',
    flexWrap: 'nowrap',
    alignItems: 'center',
    // Default to small devices
    height: theme.appBar.heightSmall,
    ['@media screen and (min-width: ' + theme.breakpoints.medium + 'px)}']: {
      height: theme.appBar.heightMedium,
    },
    ['@media screen and (min-width: ' + theme.breakpoints.large + 'px)}']: {
      height: theme.appBar.heightLarge,
    },
  },
  primary: {
    backgroundColor: theme.appBar.backgroundColor,
    color: theme.appBar.textColor,
  },
  innerLeftContainer: {
    flexBasis: 'auto',
    flexGrow: 0,
    flexShrink: 1,
    // An icon button is 2x iconSize which provides a padding of 1/2 iconSize
    marginLeft: theme.gutters.small - theme.defaultIconSize / 2 + 'px',
    marginRight: theme.gutters.small - theme.defaultIconSize / 2 + 'px',
    ['@media screen and (min-width: ' + theme.breakpoints.medium + 'px)}']: {
      marginRight: theme.gutters.medium - theme.defaultIconSize / 2 + 'px',
      marginLeft: theme.gutters.medium - theme.defaultIconSize / 2 + 'px',
    },
  },
  innerCenterContainer: {
    padding: theme.appBar.centerConPadding,
    margin: 0,
    flexBasis: 'auto',
    flexGrow: 1,
    flexShrink: 1,
    whiteSpace: 'nowrap',
    fontFamily: theme.font.fontFamily,
    lineHeight: theme.appBar.heightSmall,
    fontSize: theme.appBar.title.fontSize,
    fontWeight: theme.appBar.title.fontWeight,
    textAlign: theme.appBar.title.textAlign,
    ['@media screen and (min-width: ' + theme.breakpoints.medium + 'px)}']: {
      lineHeight: theme.appBar.heightMedium,
    },
    ['@media screen and (min-width: ' + theme.breakpoints.large + 'px)}']: {
      lineHeight: theme.appBar.heightLarge,
    },
  },
  innerRightContainer: {
    display: 'inline-block',
  },
});
