import React from 'react';
import TestRenderer from 'react-test-renderer';
import Avatar from '../Avatar';
import EmailIcon from '../../icons/svg/EmailIcon';

describe('Avatar/Avatar', () => {
  // Basic validation that render works in edit mode and returns children
  it('Should render', () => {
    const renderer = TestRenderer.create(<Avatar />);
    const testInstance = renderer.root;
    expect(testInstance.findByType(Avatar)).not.toBeNull();
  });

  it('Should render with image', () => {
    const renderer = TestRenderer.create(<Avatar src={'notfound.png'} />);
    const testInstance = renderer.root;
    expect(testInstance.findByType(Avatar)).not.toBeNull();
  });

  it('Should render with icon', () => {
    const renderer = TestRenderer.create(<Avatar icon={<EmailIcon />} />);
    const testInstance = renderer.root;
    expect(testInstance.findByType(Avatar)).not.toBeNull();
  });

  it('Should render with icon letters', () => {
    const renderer = TestRenderer.create(<Avatar iconLetters={'A'} />);
    const testInstance = renderer.root;
    expect(testInstance.findByType(Avatar)).not.toBeNull();
  });
});
