import React from 'react';
import PropTypes from 'prop-types';
import { styles } from './styles';
import injectStyles from '../styles/injectStyles';

/**
 * Show a divider (hr) on a page - usually used inside a grid but not required
 *
 * @param {Object} props
 * @returns {ReactDOM}
 */
const DividerHoriz = props => {
  const styles = props.marginsVert
    ? { marginTop: props.marginsVert, marginBottom: props.marginsVert }
    : null;
  return <div style={styles} className={props.classes.dividerHoriz} />;
};

/**
 * Set accepted properties
 */
DividerHoriz.propTypes = {
  /**
   * Optional margin above and below the line
   */
  marginsVert: PropTypes.number,

  /**
   * JSS classes for styling the component
   */
  classes: PropTypes.object,
};

export default injectStyles(styles, DividerHoriz);
