import React from 'react';
import PropTypes from 'prop-types';
import { styles } from './styles';
import injectStyles from '../styles/injectStyles';

/**
 * Horizontal spacer that is the same size as a grid gutter
 *
 * @param {Object} props
 * @returns {ReactDOM}
 */
const GutterHoriz = props => {
  return <div className={props.classes.gutterHoriz} />;
};

/**
 * Set accepted properties
 */
GutterHoriz.propTypes = {
  /**
   * JSS classes for styling the component
   */
  classes: PropTypes.object,
};

export default injectStyles(styles, GutterHoriz);
