import React from 'react';
import PropTypes from 'prop-types';
import { styles } from './styles';
import injectStyles from '../styles/injectStyles';

/**
 * Grid row
 *
 * @param props
 * @param context
 * @returns {ReactDOM}
 * @constructor
 */
const Row = (props, context) => {
  return <div className={props.classes.row}>{props.children}</div>;
};

/**
 * Set accepted properties
 */
Row.propTypes = {
  children: PropTypes.node,
};

// Wrap in JSS for styles
export default injectStyles(styles, Row);
