export const styles = theme => ({
  listItem: {
    '-webkit-touch-callout': 'none',
    userSelect: 'none',
    tapHighlightColor: 'rgba(255, 255, 255, 0);',
    position: 'relative',
    overflow: 'hidden',
    width: '100%',
    boxSizing: 'border-box',
    fontFamily: theme.font.family,
  },
  listItemTappable: {
    cursor: 'pointer',
    '&:hover': {
      '&:not(.is-disabled)': {
        'background-color': theme.list.itemHoverColor,
      },
    },
  },
  listItemContent: {
    display: 'flex',
    flexDirection: 'row',
    flexWrap: 'nowrap',
    alignItems: 'center',
    padding: theme.list.itemPadding,
  },
  listItemContentAlignTop: {
    alignItems: 'flex-start',
  },
  listItemLeft: {
    flexGrow: 0,
    flexShrink: 0,
    flexBasis: '40px',
    marginRight: theme.gutters.small + 'px',
  },
  listItemRight: {
    flexBasis: theme.defaultIconSize + 'px',
    flexGrow: 0,
    flexShrink: 0,
    textAlign: 'right',
  },
  listItemSelected: {
    color: theme.list.itemSelectedTextColor,
    backgroundColor: theme.list.itemSelectedBackgroundColor,
  },
  listItemEmphasized: {
    fontWeight: 'bold',
  },
  listItemData: {
    flexBasis: 'auto',
    flexGrow: 1,
    flexShrink: 1,
    overflow: 'hidden',
    verticalAlign: 'top',
    lineHeight: '125%',
    whiteSpace: 'nowrap',
  },

  listDivider: {
    height: '1px',
    backgroundColor: theme.borderColor,
  },
  listDividerInset: {
    marginLeft: '72px',
  },
});
