import React from 'react';
import PropTypes from 'prop-types';
import { styles } from './styles';
import injectStyles from '../styles/injectStyles';

const SubheaderMenuItem = (props, context) => {

  return (
    <div key={props.index} className={props.classes.menuSubheader}>
      {props.text}
    </div>
  );
};

SubheaderMenuItem.propTypes = {
  index: PropTypes.number.isRequired,
  text: PropTypes.string.isRequired,
};

// Wrap in JSS for styles
export default injectStyles(styles, SubheaderMenuItem);
