export const styles = theme => ({
  menu: {
    backgroundColor: theme.menu.backgroundColor,
    paddingTop: theme.gutters.mini + 'px',
    paddingBottom: theme.gutters.mini + 'px',
    '& *': {
      transition: theme.menu.easeOutDefault
    }
  },

  menuHideable: {
    opacity: 0,
    position: 'absolute',
    top: 0,
    zIndex: 1,
    overflow: 'hidden',
  },

  menuVisible: {
    overflow: 'auto',
  },

  chamelPaperContainer: {
    paddingTop: theme.gutters.mini + 'px',
    paddingTottom: theme.gutters.mini + 'px',
  },

  menuAbsoluteOnly: {
    position: 'absolute',
    zIndex: 99,
  },

  menuSubheader: {
    paddingLeft: theme.gutters.medium + 'px',
    paddingRight: theme.gutters.medium + 'px',
  },

  menuNestedMenuItem: {
    position: 'relative',
  },

  menuNextMenuItemDisabled: {
    color: theme.menu.disabledTextColor,
    cursor: 'default',
  },

  menuNextMenuItemOpenMenu: {
    opacity: 1,
  },

  menuItem: {
    cursor: 'pointer',
    whiteSpace: 'nowrap',
    lineHeight: '48px',
    paddingLeft: theme.gutters.medium + 'px',
    paddingRight: theme.gutters.medium + 'px',
    backgroundColor: theme.menu.hoverColor,

    '& *': {
      userSelect: 'none'
    },

    '&:hover': {
      '&:not(isDisabled)': {
        backgroundColor: theme.menu.hoverColor,
      }
    }
  },

  menuItemNumber: {
    float: 'right',
    width: '24px',
    textAlign: 'center',
  },

  menuItemAttribute: {
    float: 'right',
  },

  menuItemIconRight: {
    lineHeight: theme.menu.itemHeight,
    float: 'right',
  },

  menuItemIcon: {
    float: 'left',
    lineHeight: theme.menu.itemHeight,
    marginRight: theme.gutters.medium + 'px',
  },

  menuItemIndent: {
    float: 'left',
    width: '10px',
    height: theme.menu.itemHeight,
  },

  menuItemData: {
    display: 'block',
    paddingLeft: (theme.gutters.medium + 'px' * 2),
    lineHeight: theme.menu.itemDataHeight,
    height: theme.menu.itemDataHeight,
    verticalAlign: 'top',
    top: '-12px',
    position: 'relative',
    fontWeight: 300
  },

  customArrowDropRight: {
    marginRight: (theme.gutters.mini * -1) + 'px',
    color: theme.menu.iconColor,
  },

  chamelToggle: {
    marginTtop: '12px',
    float: 'right',
    width: '42px',
  },

  menuItemSelected: {
    color: theme.menu.selectedTextColor,
  },

  menuItemFocused: {
    backgroundCcolor: theme.menu.hoverColor,
  },

  menuItemDisabled: {
    color: theme.menu.disabledTextColor + ' !important',
    cursor: 'default',
  }
})
