import React from 'react';
import PropTypes from 'prop-types';
import { styles } from './styles';
import injectStyles from '../styles/injectStyles';

const Table = props => {
  let classes = props.classes.table;
  if (props.fixedWidth) {
    classes += ' ' + props.classes.tableFixedWidth;
  }

  return <table className={classes}>{props.children}</table>;
};

Table.defaultProps = {
  fixedWidth: true,
};

Table.propTypes = {
  /**
   * Contents of the cell
   */
  children: PropTypes.any,

  /**
   * If true the table layout will be fixed-width
   */
  fixedWidth: PropTypes.bool,

  /**
   * JSS classes for styling the component
   */
  classes: PropTypes.object,
};

export default injectStyles(styles, Table);
