import React from 'react';
import PropTypes from 'prop-types';
import { styles } from './styles';
import injectStyles from '../styles/injectStyles';

const Body = props => {
  return <tbody className={props.classes.tbody}>{props.children}</tbody>;
};

Body.propTypes = {
  /**
   * Contents of the cell
   */
  children: PropTypes.any,

  /**
   * JSS classes for styling the component
   */
  classes: PropTypes.object,
};

export default injectStyles(styles, Body);
