import React from 'react';
import PropTypes from 'prop-types';
import { styles } from './styles';
import injectStyles from '../styles/injectStyles';

const RowCell = props => {
  return (
    <td title={props.title} className={props.classes.cell} style={props.style}>
      {props.children}
    </td>
  );
};

RowCell.propTypes = {
  /**
   * Contents of the cell
   */
  children: PropTypes.any,

  /**
   * JSS classes for styling the component
   */
  classes: PropTypes.object,

  /**
   * Optional width of the column
   */
  width: PropTypes.string,

  /**
   * Optional style overrides - often used to set width
   */
  style: PropTypes.object,

  /**
   * Title used to tell the user somethign when they hover over a cell
   */
  title: PropTypes.string,
};

export default injectStyles(styles, RowCell);
