import React from 'react';
import TestRenderer from 'react-test-renderer';
import Row from '../TableRow';
import EmailIcon from '../../icons/svg/EmailIcon';

describe('Table Row Component', () => {
  // Basic validation that render works in edit mode and returns children
  it('Should render', () => {
    const renderer = TestRenderer.create(<Row />);
    const testInstance = renderer.root;
    expect(testInstance.findByType(Row)).not.toBeNull();
  });

  it('Should render with iconElement', () => {
    const renderer = TestRenderer.create(<Row iconElement={<EmailIcon />} />);
    const testInstance = renderer.root;
    expect(testInstance.findByType(Row)).not.toBeNull();
  });

  it('Should render without a checkbox', () => {
    const renderer = TestRenderer.create(<Row showCheckBox={false} />);
    const testInstance = renderer.root;
    expect(testInstance.findByType(Row)).not.toBeNull();
  });
});
