export const styles = theme => ({
  tabsContainer: {
    position: 'relative',
    width: '100%',
  },

  tabItemContainer: {
    margin: 0,
    padding: 0,
    width: '100%',
    height: theme.tabs.height,
    backgroundColor: theme.tabs.backgroundColor,
    'white-space': 'nowrap',
    display: 'block',
    border: theme.tabs.tabsContainerBorder,
    borderRadius: theme.tabs.tabsContainerBorderRadius,
  },

  tabItemContainerSecondary: {
    extend: 'tabItemContainer',
    backgroundColor: 'transparent',
  },

  tabTemplate: {
    display: 'block',
    width: '100%',
    position: 'relative',
    textAlign: 'initial',
  },

  tabItem: {
    display: 'inline-block',
    height: '100%',
    cursor: 'pointer',
    textAlign: 'center',
    lineHeight: theme.tabs.height,
    color: theme.tabs.textColor,
    opacity: '.6',
    fontSize: theme.tabs.fontSize,
    fontWeight: 500,
    fontFamily: theme.font.family,
  },

  tabItemIsActive: {
    color: theme.tabs.activeTextColor,
    backgroundColor: theme.tabs.activeBackgroundColor,
    opacity: 1,
    fontFamily: theme.font.family,
  },

  tabItemSecondary: {
    extend: 'tabItem',
    opacity: '.6',
    color: theme.tabs.secondaryTextColor,
  },

  tabItemSecondaryIsActive: {
    color: theme.tabs.secondaryActiveTextColor,
    opacity: 1,
    fontFamily: theme.font.family,
  },

  tabInkBar: {
    bottom: 0,
    display: 'block',
    backgroundColor: theme.tabs.inkBarBackgroundColor,
    height: '2px',
    marginTop: '-2px',
    position: 'relative',
    transition: theme.tabs.easeOutInkBar,
  },

  tabInkBarSecondary: {
    extend: 'tabInkBar',
    backgroundColor: theme.tabs.backgroundColor,
  },
});
