import React from 'react';
import PropTypes from 'prop-types';
import { styles } from './textStyles';
import injectStyles from '../styles/injectStyles';

/**
 * Lead paragraph for subheader
 *
 * @param {Object} props
 * @returns {Object}
 */
const BodyLeadText = props => {
  return (
    <p style={props.style} className={props.classes.lead}>
      {props.children}
    </p>
  );
};

/**
 * Accepted PropTypes
 */
BodyLeadText.propTypes = {
  /**
   * JSS styles
   */
  classes: PropTypes.object,

  /**
   * Contents of the header
   */
  children: PropTypes.any,

  /**
   * Optional style overrides
   */
  style: PropTypes.object,
};

// Wrap in JSS for styles
export default injectStyles(styles, BodyLeadText);
