import React from 'react';
import PropTypes from 'prop-types';
import { styles } from './textStyles';
import injectStyles from '../styles/injectStyles';

/**
 * Caption text
 *
 * @param {Object} props
 * @returns {Object}
 */
const Caption = props => {
  return (
    <div style={props.style} className={props.classes.caption}>
      {props.children}
    </div>
  );
};

/**
 * Accepted PropTypes
 */
Caption.propTypes = {
  /**
   * JSS styles
   */
  classes: PropTypes.object,

  /**
   * Contents of the header
   */
  children: PropTypes.any,

  /**
   * Optional style overrides
   */
  style: PropTypes.object,
};

// Wrap in JSS for styles
export default injectStyles(styles, Caption);
