export const styles = theme => ({
  common: {
    fontFamily: theme.font.family,
  },

  /**
   * Display headings - all special h1s
   */
  display1: {
    extend: 'common',
    fontSize: theme.font.display1.size,
    fontWeight: theme.font.display1.weight,
    color: theme.font.display1.color,
  },
  display2: {
    extend: 'common',
    fontSize: theme.font.display2.size,
    fontWeight: theme.font.display2.weight,
    color: theme.font.display2.color,
  },
  display3: {
    extend: 'common',
    fontSize: theme.font.display3.size,
    fontWeight: theme.font.display3.weight,
    color: theme.font.display3.color,
  },
  display4: {
    extend: 'common',
    fontSize: theme.font.display4.size,
    fontWeight: theme.font.display4.weight,
    color: theme.font.display4.color,
  },

  /**
   * Standard headings
   */
  heading1: {
    extend: 'common',
    fontSize: theme.font.heading1.size,
    fontWeight: theme.font.heading1.weight,
    color: theme.font.heading1.color,
  },
  heading2: {
    extend: 'common',
    fontSize: theme.font.heading2.size,
    fontWeight: theme.font.heading2.weight,
    color: theme.font.heading2.color,
  },
  heading3: {
    extend: 'common',
    fontSize: theme.font.heading3.size,
    fontWeight: theme.font.heading3.weight,
    color: theme.font.heading3.color,
  },
  heading4: {
    extend: 'common',
    fontSize: theme.font.heading4.size,
    fontWeight: theme.font.heading4.weight,
    color: theme.font.heading4.color,
  },

  /**
   * Body text styles
   */
  body: {
    extend: 'common',
    fontSize: theme.font.body.size,
    fontWeight: theme.font.body.weight
  },

  lead: {
    extend: 'common',
    fontSize: theme.font.lead.size,
    fontWeight: theme.font.lead.weight
  },

  caption: {
    extend: 'common',
    fontSize: theme.font.caption.size,
    fontWeight: theme.font.caption.weight,
  },
});
