export const styles = theme => ({
  checkbox: {
    verticalAlign: 'middle',
  },

  checkboxInput: {
    display: 'none',
  },

  checkboxIcon: {
    height: theme.toggle.checkboxSize,
    width: theme.toggle.checkboxSize,
    marginRight: theme.gutters.small + 'px',
    position: 'relative',
    display: 'inline-block',
  },

  checkboxIconCheck: {
    position: 'absolute',
    opacity: 0,
    transformOrigin: '50% 50%',
    transition: theme.toggle.transition,
    transform: 'scale(0)',

    '& *': { fill: theme.toggle.checkedColor },
  },

  checkboxIconCheckOn: {
    opacity: 1,
    transformOrigin: '50% 50%',
    transition: theme.toggle.transitionCheckOn,
    transform: 'scale(1)',
  },

  checkboxIconBox: {
    position: 'absolute',

    '& *': {
      fill: theme.toggle.uncheckedColor,
      transition: theme.toggle.easeOutIconBox,
    },
  },

  checkboxIconBoxOn: {
    transition: theme.toggle.easeOutBoxOn,

    '& *': { fill: theme.toggle.checkedColor },
  },

  checkboxText: {
    display: 'inline-block',
    height: theme.toggle.checkboxSize,
    verticalAlign: 'top',
    lineHeight: theme.toggle.checkboxSize,
  },

  switch: {
    padding: '4px 0px 6px 2px',
    marginRight: '8px',
  },

  switchIcon: {
    position: 'relative',
    height: theme.toggle.toggleSize,
    display: 'inline-block',
    width: '40px',
  },

  switchText: {
    display: 'inline-block',
    height: theme.toggle.toggleSize,
    verticalAlign: 'top',
    lineHeight: theme.toggle.toggleSize,
  },

  switchIconTrack: {
    position: 'absolute',
    top: '3.5px',
    width: '36px',
    height: '14px',
    borderRadius: '30px',
    backgroundColor: theme.toggle.trackColorOff,
    transition: theme.toggle.easeOutDefault,
  },

  switchIconTrackOn: {
    backgroundColor: theme.toggle.trackColorOn,
  },

  switchIconButton: {
    position: 'absolute',
    top: '0px',
    left: '0px',
    width: theme.toggle.toggleSize,
    height: theme.toggle.toggleSize,
    lineHeight: '24px',
    borderRadius: '50%',
    backgroundColor: theme.toggle.thumbColorOff,
    borderRadius: '50%',
    transition: theme.toggle.easeOutDefault,
  },

  chamelTouchRipple: {
    width: '200%',
    height: '200%',
    top: '-10px',
    left: '-10px',
  },

  chamelFocusRippleInner: {
    extend: 'chamelTouchRipple',
  },

  switchIconButtonOn: {
    left: '18px',
    backgroundColor: theme.toggle.thumbColorOn,
  },
});
