import React, { Component } from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { styles } from './styles';
import injectStyles from '../styles/injectStyles';

/**
 * Main popover class handles absolute positioning paper relative to an element
 */
class ToolbarGroup extends Component {
  /**
   * Class constructor
   *
   * @param {Object} props Properties to send to the render function
   */
  constructor(props) {
    // Call paprent constructor
    super(props);
  }

  /**
   * Set accepted properties
   */
  static propTypes = {
    align: PropTypes.string,
  };

  render() {
    const propsClasses = this.props.classes;
    const classes = classnames(propsClasses.toolbarGroup, {
      [propsClasses.toolbarGroupLeft]: this.props.align === 'left',
      [propsClasses.toolbarGroupRight]: this.props.align === 'right',
    });

    return <div className={classes}>{this.props.children}</div>;
  }
}

// Wrap in JSS for styles
export default injectStyles(styles, ToolbarGroup);
