import React from 'react';
import PropTypes from 'prop-types';
import FontIcon from '../../FontIcon';
import { styles } from './styles';
import injectStyles from '../../styles/injectStyles';

/**
 * AccessTime button
 *
 * @param props
 * @param context
 * @returns {ReactDOM}
 * @constructor
 */
const AccessTimeIcon = (props, context) => {
  return (
    <FontIcon {...props} className={props.classes.iconAccessTime}>
      {'access_time'}
    </FontIcon>
  );
};

// Wrap in JSS for styles
export default injectStyles(styles, AccessTimeIcon);
