import React from 'react';
import PropTypes from 'prop-types';
import FontIcon from '../../FontIcon';
import { styles } from './styles';
import injectStyles from '../../styles/injectStyles';

/**
 * Bold Icon button
 *
 * @param props
 * @param context
 * @returns {ReactDOM}
 * @constructor
 */
const BoldIcon = (props, context) => {
  return (
    <FontIcon {...props} className={props.classes.iconBold}>
      {'format_bold'}
    </FontIcon>
  );
};

// Wrap in JSS for styles
export default injectStyles(styles, BoldIcon);
