import React from 'react';
import PropTypes from 'prop-types';
import FontIcon from '../../FontIcon';
import { styles } from './styles';
import injectStyles from '../../styles/injectStyles';

/**
 * Check Circle button
 *
 * @param props
 * @param context
 * @returns {ReactDOM}
 * @constructor
 */
const CheckCircleIcon = (props, context) => {
  return (
    <FontIcon {...props} className={props.classes.iconCheckCircle}>
      {'check_circle'}
    </FontIcon>
  );
};

// Wrap in JSS for styles
export default injectStyles(styles, CheckCircleIcon);
