import React from 'react';
import PropTypes from 'prop-types';
import FontIcon from '../../FontIcon';
import { styles } from './styles';
import injectStyles from '../../styles/injectStyles';

/**
 * ContentPaste button
 *
 * @param props
 * @param context
 * @returns {ReactDOM}
 * @constructor
 */
const ContentPasteIcon = (props, context) => {
  return (
    <FontIcon {...props} className={props.classes.iconContentPaste}>
      {'content_paste'}
    </FontIcon>
  );
};

// Wrap in JSS for styles
export default injectStyles(styles, ContentPasteIcon);
