import React from 'react';
import PropTypes from 'prop-types';
import FontIcon from '../../FontIcon';
import { styles } from './styles';
import injectStyles from '../../styles/injectStyles';

/**
 * DateRange button
 *
 * @param props
 * @param context
 * @returns {ReactDOM}
 * @constructor
 */
const DateRangeIcon = (props, context) => {
  return (
    <FontIcon {...props} className={props.classes.iconDateRange}>
      {'date_range'}
    </FontIcon>
  );
};

// Wrap in JSS for styles
export default injectStyles(styles, DateRangeIcon);
