import React from 'react';
import PropTypes from 'prop-types';
import FontIcon from '../../FontIcon';
import { styles } from './styles';
import injectStyles from '../../styles/injectStyles';

/**
 * FindPage button
 *
 * @param props
 * @param context
 * @returns {ReactDOM}
 * @constructor
 */
const FindPageIcon = (props, context) => {
  return (
    <FontIcon {...props} className={props.classes.iconFindPage}>
      {'find_in_page'}
    </FontIcon>
  );
};

// Wrap in JSS for styles
export default injectStyles(styles, FindPageIcon);
