import React from 'react';
import PropTypes from 'prop-types';
import FontIcon from '../../FontIcon';
import { styles } from './styles';
import injectStyles from '../../styles/injectStyles';

/**
 * LibraryBooks button
 *
 * @param props
 * @param context
 * @returns {ReactDOM}
 * @constructor
 */
const LibraryBooksIcon = (props, context) => {
  return (
    <FontIcon {...props} className={props.classes.iconLibraryBooks}>
      {'library_books'}
    </FontIcon>
  );
};

// Wrap in JSS for styles
export default injectStyles(styles, LibraryBooksIcon);
