import React from 'react';
import PropTypes from 'prop-types';
import FontIcon from '../../FontIcon';
import { styles } from './styles';
import injectStyles from '../../styles/injectStyles';

/**
 * List Unordered button
 *
 * @param props
 * @param context
 * @returns {ReactDOM}
 * @constructor
 */
const ListBulletedIcon = (props, context) => {
  return (
    <FontIcon {...props} className={props.classes.iconListBulleted}>
      {'format_list_bulleted'}
    </FontIcon>
  );
};

// Wrap in JSS for styles
export default injectStyles(styles, ListBulletedIcon);
