import React from 'react';
import PropTypes from 'prop-types';
import FontIcon from '../../FontIcon';
import { styles } from './styles';
import injectStyles from '../../styles/injectStyles';

/**
 * List Ordered Icon button
 *
 * @param props
 * @param context
 * @returns {ReactDOM}
 * @constructor
 */
const ListNumberedIcon = (props, context) => {
  return (
    <FontIcon {...props} className={props.classes.iconListNumbered}>
      {'format_list_numbered'}
    </FontIcon>
  );
};

// Wrap in JSS for styles
export default injectStyles(styles, ListNumberedIcon);
