import React from 'react';
import PropTypes from 'prop-types';
import FontIcon from '../../FontIcon';
import { styles } from './styles';
import injectStyles from '../../styles/injectStyles';

/**
 * PhotoCamera button
 *
 * @param props
 * @param context
 * @returns {ReactDOM}
 * @constructor
 */
const PhotoCameraIcon = (props, context) => {
  return (
    <FontIcon {...props} className={props.classes.iconPhotoCamera}>
      {'photo_camera'}
    </FontIcon>
  );
};

// Wrap in JSS for styles
export default injectStyles(styles, PhotoCameraIcon);
