import React from 'react';
import PropTypes from 'prop-types';
import FontIcon from '../../FontIcon';
import { styles } from './styles';
import injectStyles from '../../styles/injectStyles';

/**
 * Photo button
 *
 * @param props
 * @param context
 * @returns {ReactDOM}
 * @constructor
 */
const PhotoIcon = (props, context) => {
  return (
    <FontIcon {...props} className={props.classes.iconPhoto}>
      {'photo'}
    </FontIcon>
  );
};

// Wrap in JSS for styles
export default injectStyles(styles, PhotoIcon);
