import React from 'react';
import PropTypes from 'prop-types';
import FontIcon from '../../FontIcon';
import { styles } from './styles';
import injectStyles from '../../styles/injectStyles';

/**
 * Title Icon button
 *
 * @param props
 * @param context
 * @returns {ReactDOM}
 * @constructor
 */
const TitleIcon = (props, context) => {
  let fontIconProps = { ...props };

  let headerType = null;
  if (props.headerType) {
    headerType = props.headerType;
    delete fontIconProps.headerType;
  }

  return (
    <div>
      <FontIcon {...fontIconProps} className={props.classes.iconTitle}>
        {'title'}
      </FontIcon>
      <span className={props.classes.iconTitleType}>{headerType}</span>
    </div>
  );
};

// Wrap in JSS for styles
export default injectStyles(styles, TitleIcon);
