import React from 'react';
import PropTypes from 'prop-types';
import FontIcon from '../../FontIcon';
import { styles } from './styles';
import injectStyles from '../../styles/injectStyles';

/**
 * Underline Icon button
 *
 * @param props
 * @param context
 * @returns {ReactDOM}
 * @constructor
 */
const UnderlinedIcon = (props, context) => {
  return (
    <FontIcon {...props} className={props.classes.iconUnderlined}>
      {'format_underlined'}
    </FontIcon>
  );
};

// Wrap in JSS for styles
export default injectStyles(styles, UnderlinedIcon);
