import AccessTimeIcon from './AccessTimeIcon';
import AccessibilityIcon from './AccessibilityIcon';
import AccountIcon from './AccountIcon';
import AddIcon from './AddIcon';
import AddCircleIcon from './AddCircleIcon';
import AnnouncementIcon from './AnnouncementIcon';
import AppsIcon from './AppsIcon';
import ArrowBackIcon from './ArrowBackIcon';
import ArrowDownIcon from './ArrowDownIcon';
import ArrowDropDownIcon from './ArrowDropDownIcon';
import ArrowDropDownCircleIcon from './ArrowDropDownCircleIcon';
import ArrowDropUpIcon from './ArrowDropUpIcon';
import ArrowForwardIcon from './ArrowForwardIcon';
import ArrowRightIcon from './ArrowRightIcon';
import ArrowUpIcon from './ArrowUpIcon';
import AttachmentIcon from './AttachmentIcon';
import AttachFileIcon from './AttachFileIcon';
import BoldIcon from './BoldIcon';
import BorderColorIcon from './BorderColorIcon';
import BuildIcon from './BuildIcon';
import CancelIcon from './CancelIcon';
import CheckIcon from './CheckIcon';
import CheckCircleIcon from './CheckCircleIcon';
import ChevronLeftIcon from './ChevronLeftIcon';
import ChevronRightIcon from './ChevronRightIcon';
import CloseIcon from './CloseIcon';
import CodeIcon from './CodeIcon';
import CommentIcon from './CommentIcon';
import ContactsIcon from './ContactsIcon';
import ContentPaste from './ContentPaste';
import DashboardIcon from './DashboardIcon';
import DateRangeIcon from './DateRangeIcon';
import DeleteIcon from './DeleteIcon';
import EditIcon from './EditIcon';
import EmailIcon from './EmailIcon';
import ExpandLessIcon from './ExpandLessIcon';
import ExpandMoreIcon from './ExpandMoreIcon';
import FilterListIcon from './FilterListIcon';
import FindPageIcon from './FindPageIcon';
import FirstPageIcon from './FirstPageIcon';
import FlagIcon from './FlagIcon';
import FullScreenIcon from './FullScreenIcon';
import FullScreenExitIcon from './FullScreenExitIcon';
import GroupIcon from './GroupIcon';
import InboxIcon from './InboxIcon';
import ItalicIcon from './ItalicIcon';
import LabelIcon from './LabelIcon';
import LastPageIcon from './LastPageIcon';
import LibraryBooksIcon from './LibraryBooksIcon';
import LinkIcon from './LinkIcon';
import ListNumberedIcon from './ListNumberedIcon';
import ListBulletedIcon from './ListBulletedIcon';
import LocalOfferIcon from './LocalOfferIcon';
import MenuIcon from './MenuIcon';
import MergeIcon from './MergeIcon';
import MoreHorizIcon from './MoreHorizIcon';
import MoreVertIcon from './MoreVertIcon';
import NoteIcon from './NoteIcon';
import PersonAddIcon from './PersonAddIcon';
import PhotoIcon from './PhotoIcon';
import PhotoCameraIcon from './PhotoCameraIcon';
import PrintIcon from './PrintIcon';
import RefreshIcon from './RefreshIcon';
import SaveIcon from './SaveIcon';
import SearchIcon from './SearchIcon';
import SendIcon from './SendIcon';
import SettingsIcon from './SettingsIcon';
import SettingsApplication from './SettingsApplication';
import ShuffleIcon from './ShuffleIcon';
import StreetViewIcon from './StreetViewIcon';
import StyleIcon from './StyleIcon';
import SubArrowLeftIcon from './SubArrowLeftIcon';
import SubArrowRightIcon from './SubArrowRightIcon';
import SwapHorizIcon from './SwapHorizIcon';
import TitleIcon from './TitleIcon';
import TransformIcon from './TransformIcon';
import ViewListIcon from './ViewListIcon';
import WebIcon from './WebIcon';
import WorkIcon from './WorkIcon';
import UnderlinedIcon from './UnderlinedIcon';

const Icons = {
  navigation: [
    { name: 'accessibility', icon: AccessibilityIcon },
    { name: 'account', icon: AccountIcon },
    { name: 'add', icon: AddIcon },
    { name: 'add circle', icon: AddCircleIcon },
    { name: 'Announcement', icon: AnnouncementIcon },
    { name: 'apps', icon: AppsIcon },
    { name: 'arrow back', icon: ArrowBackIcon },
    { name: 'arrow down', icon: ArrowDownIcon },
    { name: 'arrow drop down', icon: ArrowDropDownIcon },
    { name: 'arrow drop down circle', icon: ArrowDropDownCircleIcon },
    { name: 'arrow drop up', icon: ArrowDropUpIcon },
    { name: 'arrow forward', icon: ArrowForwardIcon },
    { name: 'arrow right', icon: ArrowRightIcon },
    { name: 'arrow up', icon: ArrowUpIcon },
    { name: 'attachment', icon: AttachmentIcon },
    { name: 'attach file', icon: AttachFileIcon },
    { name: 'border color', icon: BorderColorIcon },
    { name: 'build', icon: BuildIcon },
    { name: 'cancel', icon: CancelIcon },
    { name: 'check', icon: CheckIcon },
    { name: 'check circle', icon: CheckCircleIcon },
    { name: 'chevron left', icon: ChevronLeftIcon },
    { name: 'chevron right', icon: ChevronRightIcon },
    { name: 'close', icon: CloseIcon },
    { name: 'clipboard', icon: ContentPaste },
    { name: 'comment', icon: CommentIcon },
    { name: 'contacts', icon: ContactsIcon },
    { name: 'dashboard', icon: DashboardIcon },
    { name: 'date range', icon: DateRangeIcon },
    { name: 'delete', icon: DeleteIcon },
    { name: 'edit', icon: EditIcon },
    { name: 'email', icon: EmailIcon },
    { name: 'exit full screen', icon: FullScreenExitIcon },
    { name: 'expand less', icon: ExpandLessIcon },
    { name: 'expand more', icon: ExpandMoreIcon },
    { name: 'filter list', icon: FilterListIcon },
    { name: 'find page', icon: FindPageIcon },
    { name: 'first page', icon: FirstPageIcon },
    { name: 'flag', icon: FlagIcon },
    { name: 'full screen', icon: FullScreenIcon },
    { name: 'group', icon: GroupIcon },
    { name: 'inbox', icon: InboxIcon },
    { name: 'label', icon: LabelIcon },
    { name: 'last page', icon: LastPageIcon },
    { name: 'library books', icon: LibraryBooksIcon },
    { name: 'menu', icon: MenuIcon },
    { name: 'merge', icon: MergeIcon },
    { name: 'more horiz', icon: MoreHorizIcon },
    { name: 'more vert', icon: MoreVertIcon },
    { name: 'note', icon: NoteIcon },
    { name: 'person add', icon: PersonAddIcon },
    { name: 'photo', icon: PhotoIcon },
    { name: 'photo camera', icon: PhotoCameraIcon },
    { name: 'print', icon: PrintIcon },
    { name: 'refresh', icon: RefreshIcon },
    { name: 'save', icon: SaveIcon },
    { name: 'search', icon: SearchIcon },
    { name: 'send', icon: SendIcon },
    { name: 'settings', icon: SettingsIcon },
    { name: 'settings application', icon: SettingsApplication },
    { name: 'shuffle', icon: ShuffleIcon },
    { name: 'street view', icon: StreetViewIcon },
    { name: 'sub arrow left', icon: SubArrowLeftIcon },
    { name: 'sub arrow right', icon: SubArrowRightIcon },
    { name: 'swap horiz', icon: SwapHorizIcon },
    { name: 'tag', icon: LocalOfferIcon },
    { name: 'tags', icon: StyleIcon },
    { name: 'transform', icon: TransformIcon },
    { name: 'time', icon: AccessTimeIcon },
    { name: 'view list', icon: ViewListIcon },
    { name: 'work', icon: WorkIcon },
  ],

  editor: [
    { name: 'bold', icon: BoldIcon },
    { name: 'code', icon: CodeIcon },
    { name: 'italic', icon: ItalicIcon },
    { name: 'link', icon: LinkIcon },
    { name: 'list numbered', icon: ListNumberedIcon },
    { name: 'list bulleted', icon: ListBulletedIcon },
    { name: 'title', icon: TitleIcon },
    { name: 'web', icon: WebIcon },
    { name: 'underlined', icon: UnderlinedIcon },
  ],
};

export default Icons;
