export const styles = theme => ({
  '@font-face': {
    fontFamily: "'Material Icons'",
    fontStyle: 'normal',
    fontWeight: 400,
    /* For IE6-8 */
    src: 'url("../fonts/MaterialIcons-Regular.eot")',
    src:
    'local("Material Icons"), local("MaterialIcons-Regular"),' +
    'url("../fonts/MaterialIcons-Regular.woff2") format("woff2"),' +
    'url("../fonts/MaterialIcons-Regular.woff") format("woff"),' +
    'url("../fonts/MaterialIcons-Regular.ttf") format("truetype")',
    /*
     src: local('Material Icons'), local('MaterialIcons-Regular'), url(https://fonts.gstatic.com/s/materialicons/v18/2fcrYFNaTjcS6g4U3t-Y5UEw0lE80llgEseQY3FEmqw.woff2) format('woff2'),
     */
  },

  'material-icons': {
    fontFamily: 'Material Icons',
    fontWeight: 'normal',
    fontStyle: 'normal',
    fontSize: '24px' /* Preferred icon size */,
    display: 'inline-block',
    lineHeight: 1,
    textTransform: 'none',
    letterSpacing: 'normal',
    wordWrap: 'normal',
    whiteSpace: 'nowrap',
    direction: 'ltr',
    verticalAlign: 'middle',

    /* Support for all WebKit browsers. */
    '-webkit-font-smoothing': 'antialiased',
    /* Support for Safari and Chrome. */
    'text-rendering': 'optimizeLegibility',

    /* Support for Firefox. */
    '-moz-osx-font-smoothing': 'grayscale',

    /* Support for IE. */
    'font-feature-settings': 'liga',

    '&md-18': {
      fontSize: '18px !important',
    },

    '&md-24': {
      fontSize: '24px !important',
    },

    '&md-36': {
      fontSize: '36px !important',
    },

    '&md-48': {
      fontSize: '48px !important',
    },

    /* Rules for using icons as black on a light background. */
    '&md-dark': {
      color: theme.font.colorScheme.dark,
      '&md-inactive': {
        color: theme.font.colorScheme.darkInactive,
      },
    },

    /* Rules for using icons as white on a dark background. */
    '&md-light': {
      color: theme.font.colorScheme.light,
      '&md-inactive': {
        color: theme.font.colorScheme.lightInactive,
      },
    },
  },

  /**
   * Navigation Icons
   */
  iconAccessibility: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconAccessTime: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconAccount: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconAdd: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconAddCircle: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconAnnouncement: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconApps: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconArrowBack: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconArrowDown: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconArrowDropDown: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconArrowDropDownCircle: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconArrowDropUp: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconArrowForward: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconArrowRight: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconArrowUp: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconAttachment: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconAttachFile: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconBorderColor: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconBuild: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconCancel: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconCheck: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconCheckCircle: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconChevronLeft: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconChevronRight: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconClose: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconCode: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconComment: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconContacts: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconContentPaste: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconDashboard: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconDateRange: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconDelete: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconEdit: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconEmail: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconExpandLess: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconExpandMore: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconFilterList: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconFindPage: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconFirstPage: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconFlag: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconFullScreen: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconFullScreenExit: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconGroup: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconInbox: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconLabel: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconLastPage: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconLibraryBooks: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconLocalOffer: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconMenu: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconMerge: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconMoreHoriz: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconMoreVert: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconNote: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconPersonAdd: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconPhoto: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconPhotoCamera: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconPrint: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconRefresh: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconSave: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconSearch: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconSend: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconSettings: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconSettingsApplication: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconShuffle: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconStreetView: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconStyle: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconSubArrowLeft: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconSubArrowRight: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconSwapHoriz: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconTransform: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconViewList: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconWeb: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconWork: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  /**
   * Editor Icons
   */

  iconBold: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconUnderlined: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconItalic: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconLink: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconListNumbered: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconListBulleted: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconTitle: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },

  iconTitleType: {
    position: 'absolute',
    top: '20px',
    left: '35px',
  },

  /*
   * Something else
   */
  iconCreate: {
    extend: 'fontIcon',
    extend: 'material-icons',
  },
});
