import AccessTimeIcon from './svg/AccessTimeIcon';
import AccessibilityIcon from './svg/AccessibilityIcon';
import AccountIcon from './svg/AccountIcon';
import AccountProfileIcon from './svg/AccountProfileIcon';
import AddIcon from './svg/AddIcon';
import AddCircleIcon from './svg/AddCircleIcon';
import AnnouncementIcon from './svg/AnnouncementIcon';
import AppsIcon from './svg/AppsIcon';
import ArrowBackIcon from './svg/ArrowBackIcon';
import ArrowDownIcon from './svg/ArrowDownIcon';
import ArrowDropDownIcon from './svg/ArrowDropDownIcon';
import ArrowDropDownCircleIcon from './svg/ArrowDropDownCircleIcon';
import ArrowDropUpIcon from './svg/ArrowDropUpIcon';
import ArrowForwardIcon from './svg/ArrowForwardIcon';
import ArrowRightIcon from './svg/ArrowRightIcon';
import ArrowUpIcon from './svg/ArrowUpIcon';
import AssignmentIcon from './svg/AssignmentIcon';
import AttachmentIcon from './svg/AttachmentIcon';
import AttachFileIcon from './svg/AttachFileIcon';
import BoldIcon from './svg/BoldIcon';
import BorderColorIcon from './svg/BorderColorIcon';
import BuildIcon from './svg/BuildIcon';
import CancelIcon from './svg/CancelIcon';
import CheckIcon from './svg/CheckIcon';
import CheckCircleIcon from './svg/CheckCircleIcon';
import ChevronLeftIcon from './svg/ChevronLeftIcon';
import ChevronRightIcon from './svg/ChevronRightIcon';
import CloseIcon from './svg/CloseIcon';
import CodeIcon from './svg/CodeIcon';
import CommentIcon from './svg/CommentIcon';
import ContactsIcon from './svg/ContactsIcon';
import ContentPaste from './svg/ContentPasteIcon';
import DashboardIcon from './svg/DashboardIcon';
import DateRangeIcon from './svg/DateRangeIcon';
import DeleteIcon from './svg/DeleteIcon';
import DescriptionIcon from './svg/DescriptionIcon';
import EditIcon from './svg/EditIcon';
import EmailIcon from './svg/EmailIcon';
import ExpandLessIcon from './svg/ExpandLessIcon';
import ExpandMoreIcon from './svg/ExpandMoreIcon';
import ExtensionIcon from './svg/ExtensionIcon';
import FilterListIcon from './svg/FilterListIcon';
import FindPageIcon from './svg/FindPageIcon';
import FirstPageIcon from './svg/FirstPageIcon';
import FlagIcon from './svg/FlagIcon';
import FullScreenIcon from './svg/FullScreenIcon';
import FullScreenExitIcon from './svg/FullScreenExitIcon';
import GroupIcon from './svg/GroupIcon';
import HomeIcon from './svg/HomeIcon';
import InboxIcon from './svg/InboxIcon';
import ItalicIcon from './svg/ItalicIcon';
import KeyIcon from './svg/KeyIcon';
import LabelIcon from './svg/LabelIcon';
import LastPageIcon from './svg/LastPageIcon';
import LibraryBooksIcon from './svg/LibraryBooksIcon';
import LightBulbIcon from './svg/LightBulbIcon';
import LinkIcon from './svg/LinkIcon';
import ListNumberedIcon from './svg/ListNumberedIcon';
import ListBulletedIcon from './svg/ListBulletedIcon';
import LocalLibraryIcon from './svg/LocalLibraryIcon';
import LocalOfferIcon from './svg/LocalOfferIcon';
import LogOutIcon from './svg/LogOutIcon';
import MenuIcon from './svg/MenuIcon';
import MergeIcon from './svg/MergeIcon';
import MoreHorizIcon from './svg/MoreHorizIcon';
import MoreVertIcon from './svg/MoreVertIcon';
import NoteIcon from './svg/NoteIcon';
import PdfIcon from './svg/PdfIcon';
import PermMediaIcon from './svg/PermMediaIcon';
import PersonAddIcon from './svg/PersonAddIcon';
import PhotoIcon from './svg/PhotoIcon';
import PhotoCameraIcon from './svg/PhotoCameraIcon';
import PrintIcon from './svg/PrintIcon';
import RefreshIcon from './svg/RefreshIcon';
import SaveIcon from './svg/SaveIcon';
import SearchIcon from './svg/SearchIcon';
import SendIcon from './svg/SendIcon';
import SettingsIcon from './svg/SettingsIcon';
import SettingsApplicationsIcon from './svg/SettingsApplicationsIcon';
import ShuffleIcon from './svg/ShuffleIcon';
import StreetViewIcon from './svg/StreetViewIcon';
import StyleIcon from './svg/StyleIcon';
import SubArrowLeftIcon from './svg/SubArrowLeftIcon';
import SubArrowRightIcon from './svg/SubArrowRightIcon';
import SwapHorizIcon from './svg/SwapHorizIcon';
import TitleIcon from './svg/TitleIcon';
import TocIcon from './svg/TocIcon';
import TransformIcon from './svg/TransformIcon';
import ViewListIcon from './svg/ViewListIcon';
import WebIcon from './svg/WebIcon';
import WorkIcon from './svg/WorkIcon';
import UnderlinedIcon from './svg/UnderlinedIcon';

const Icons = {
  navigation: [
    { name: 'accessibility', icon: AccessibilityIcon },
    { name: 'account', icon: AccountIcon },
    { name: 'account profile', icon: AccountProfileIcon },
    { name: 'add', icon: AddIcon },
    { name: 'add circle', icon: AddCircleIcon },
    { name: 'Announcement', icon: AnnouncementIcon },
    { name: 'apps', icon: AppsIcon },
    { name: 'arrow back', icon: ArrowBackIcon },
    { name: 'arrow down', icon: ArrowDownIcon },
    { name: 'arrow drop down', icon: ArrowDropDownIcon },
    { name: 'arrow drop down circle', icon: ArrowDropDownCircleIcon },
    { name: 'arrow drop up', icon: ArrowDropUpIcon },
    { name: 'arrow forward', icon: ArrowForwardIcon },
    { name: 'arrow right', icon: ArrowRightIcon },
    { name: 'arrow up', icon: ArrowUpIcon },
    { name: 'assignment', icon: AssignmentIcon },
    { name: 'attachment', icon: AttachmentIcon },
    { name: 'attach file', icon: AttachFileIcon },
    { name: 'border color', icon: BorderColorIcon },
    { name: 'build', icon: BuildIcon },
    { name: 'cancel', icon: CancelIcon },
    { name: 'check', icon: CheckIcon },
    { name: 'check circle', icon: CheckCircleIcon },
    { name: 'chevron left', icon: ChevronLeftIcon },
    { name: 'chevron right', icon: ChevronRightIcon },
    { name: 'close', icon: CloseIcon },
    { name: 'clipboard', icon: ContentPaste },
    { name: 'comment', icon: CommentIcon },
    { name: 'contacts', icon: ContactsIcon },
    { name: 'dashboard', icon: DashboardIcon },
    { name: 'date range', icon: DateRangeIcon },
    { name: 'delete', icon: DeleteIcon },
    { name: 'description', icon: DescriptionIcon },
    { name: 'edit', icon: EditIcon },
    { name: 'email', icon: EmailIcon },
    { name: 'exit full screen', icon: FullScreenExitIcon },
    { name: 'expand less', icon: ExpandLessIcon },
    { name: 'expand more', icon: ExpandMoreIcon },
    { name: 'extension', icon: ExtensionIcon },
    { name: 'filter list', icon: FilterListIcon },
    { name: 'find page', icon: FindPageIcon },
    { name: 'first page', icon: FirstPageIcon },
    { name: 'flag', icon: FlagIcon },
    { name: 'full screen', icon: FullScreenIcon },
    { name: 'group', icon: GroupIcon },
    { name: 'home', icon: HomeIcon },
    { name: 'inbox', icon: InboxIcon },
    { name: 'key', icon: KeyIcon },
    { name: 'label', icon: LabelIcon },
    { name: 'last page', icon: LastPageIcon },
    { name: 'library books', icon: LibraryBooksIcon },
    { name: 'light bulb', icon: LightBulbIcon },
    { name: 'local library', icon: LocalLibraryIcon },
    { name: 'logout', icon: LogOutIcon },
    { name: 'menu', icon: MenuIcon },
    { name: 'merge', icon: MergeIcon },
    { name: 'more horiz', icon: MoreHorizIcon },
    { name: 'more vert', icon: MoreVertIcon },
    { name: 'note', icon: NoteIcon },
    { name: 'pdf', icon: PdfIcon },
    { name: 'perm media', icon: PermMediaIcon },
    { name: 'person add', icon: PersonAddIcon },
    { name: 'photo', icon: PhotoIcon },
    { name: 'photo camera', icon: PhotoCameraIcon },
    { name: 'print', icon: PrintIcon },
    { name: 'refresh', icon: RefreshIcon },
    { name: 'save', icon: SaveIcon },
    { name: 'search', icon: SearchIcon },
    { name: 'send', icon: SendIcon },
    { name: 'settings', icon: SettingsIcon },
    { name: 'settings application', icon: SettingsApplicationsIcon },
    { name: 'shuffle', icon: ShuffleIcon },
    { name: 'street view', icon: StreetViewIcon },
    { name: 'sub arrow left', icon: SubArrowLeftIcon },
    { name: 'sub arrow right', icon: SubArrowRightIcon },
    { name: 'swap horiz', icon: SwapHorizIcon },
    { name: 'tag', icon: LocalOfferIcon },
    { name: 'tags', icon: StyleIcon },
    { name: 'transform', icon: TransformIcon },
    { name: 'time', icon: AccessTimeIcon },
    { name: 'toc', icon: TocIcon },
    { name: 'view list', icon: ViewListIcon },
    { name: 'work', icon: WorkIcon },
  ],

  editor: [
    { name: 'bold', icon: BoldIcon },
    { name: 'code', icon: CodeIcon },
    { name: 'italic', icon: ItalicIcon },
    { name: 'link', icon: LinkIcon },
    { name: 'list numbered', icon: ListNumberedIcon },
    { name: 'list bulleted', icon: ListBulletedIcon },
    { name: 'title', icon: TitleIcon },
    { name: 'web', icon: WebIcon },
    { name: 'underlined', icon: UnderlinedIcon },
  ],
};

export default Icons;
