import React, { Component } from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { styles } from './styles';
import injectStyles from '../styles/injectStyles';

class CircleRipple extends Component {
  /**
   * Set accepted properties
   */
  static propTypes = {
    className: PropTypes.string,
    started: PropTypes.bool,
    ending: PropTypes.bool,
    style: PropTypes.object,
  };

  render() {
    const propsClasses = this.props.classes;
    let classes = classnames(propsClasses.rippleCircle, {
      [propsClasses.rippleCircleIsStarted]: this.props.started,
      [propsClasses.rippleCircleIsEnding]: this.props.ending,
    });

    let innerClasses = classnames(propsClasses.rippleCircleInner, {
      [propsClasses.rippleCircleIsStartedInner]: this.props.started,
    });

    return (
      <div className={classes} style={this.props.style}>
        <div className={innerClasses} />
      </div>
    );
  }
}

// Wrap in JSS for styles
export default injectStyles(styles, CircleRipple);
