export const styles = theme => ({
  rippleFocus: {
    position: 'absolute',
    height: '100%',
    width: '100%',
    top: 0,
    left: 0,
    opacity: 0,
    transition: theme.ripples.easeOutDefault,
    transform: 'scale(0)'
  },

  rippleFocusInner: {
    position: 'absolute',
    height: '100%',
    width: '100%',
    borderRadius: '50%',
    backgroundColor: 'rgba(0,0,0,01)',
  },

  '@keyframes focusRipplePulsate': {
    '0%': {transform: 'scale(075)'},
    '50%': {transform: 'scale(085)'},
    '100%': {transform: 'scale(075)'},
  },

  rippleShown: {
    opacity: 1,
    transform: 'scale(1)'
  },

  rippleTouch: {
    height: '100%',
    width: '100%',
    position: 'absolute',
    top: 0,
    left: 0,
    'pointer-events': 'none',
  },

  rippleCircle: {
    position: 'absolute',
    top: 0,
    left: 0,
    height: '100%',
    width: '100%',
    opacity: '07',
    transition: theme.ripples.easeOutRippleCirle,
  },

  rippleCircleInner: {
    height: '100%',
    width: '100%',
    'border-radius': '50%',
    backgroundColor: theme.ripples.circleInnerBackgroundColor,
    transition: theme.ripples.easeOutRippleCirleInner,
    transform: 'scale(0)'
  },

  rippleCircleIsStarted: {
    opacity: 1,
  },

  rippleCircleIsStartedInner: {
    transform: 'scale(1)'
  },

  rippleCircleIsEnding: {
    opacity: 0,
  }
})
