import React from 'react';
import { getTheme } from '../themeAutoSelector';

describe('styles/themeAutoselector', () => {
  it('getTheme should return a theme for android', () => {
    const uaMock = {
      getOS: function() {
        return { name: 'Android' };
      },
      getBrowser: function() {
        return { name: 'Chrome' };
      },
    };
    expect(getTheme(uaMock)).not.toBeNull();
  });

  it('getTheme should return a theme for windows', () => {
    const uaMock = {
      getOS: function() {
        return { name: 'Windows' };
      },
      getBrowser: function() {
        return { name: 'Chrome' };
      },
    };
    expect(getTheme(uaMock)).not.toBeNull();
  });

  it('getTheme should return a theme for ios', () => {
    const uaMock = {
      getOS: function() {
        return { name: 'ios' };
      },
      getBrowser: function() {
        return { name: 'Chrome' };
      },
    };
    expect(getTheme(uaMock)).not.toBeNull();
  });
});
