import { themeBuilder } from './themeBuilder';

/**
 * Import all themes
 */
import base from './theme-base';
import materialTheme from './theme-material';
import modernTheme from './theme-modern';
import humanTheme from './theme-human';

// Merge with base and export the google material theme
export const material = themeBuilder(materialTheme, base);

// Merge with base and export microsoft modern
export const modern = themeBuilder(modernTheme, base);

// Merge with base and export the apple human theme
export const human = themeBuilder(humanTheme, base);

export default material;
