import Events from './Events';

const testSupportedProps = props => {
  var i,
    undefined,
    el = document.createElement('div');

  for (i in props) {
    if (props.hasOwnProperty(i) && el.style[i] !== undefined) {
      return props[i];
    }
  }
};

/* 
 * Returns the correct event name to use
 */
export const transitionEndEventName = () => {
  return testSupportedProps({
    transition: 'transitionend',
    OTransition: 'otransitionend',
    MozTransition: 'transitionend',
    WebkitTransition: 'webkitTransitionEnd',
  });
};

export const animationEndEventName = () => {
  return testSupportedProps({
    animation: 'animationend',
    '-o-animation': 'oAnimationEnd',
    '-moz-animation': 'animationend',
    '-webkit-animation': 'webkitAnimationEnd',
  });
};

export const onTransitionEnd = (el, callback) => {
  var transitionEnd = this.transitionEndEventName();

  Events.once(el, transitionEnd, function() {
    return callback();
  });
};

export const onAnimationEnd = (el, callback) => {
  var animationEnd = this.animationEndEventName();

  Events.once(el, animationEnd, function() {
    return callback();
  });
};

export default {
  transitionEndEventName,
  animationEndEventName,
  onTransitionEnd,
  onAnimationEnd,
};
